(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KS.PAS                                                         *)
(*  Obsah: hra Kosmostrelci - kompletni zdrojak                            *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 13.7.2008                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: KSDATA1.DAT, KSDATA2.DAT, KSINTRO1.DAT, KSINTRO2.DAT,    *)
(*                dale pak DEFAULT.PCX, DEFAULT1.LOD A DEFAULT2.LOD        *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program GalaxyShooters;
{$N+,E-,I-}
{$M 32768,0,655360} {vetsi zasobnik je nutnost, vychozich 16 KB nestaci}
uses intro,vesa,umac3,klavesy,matyka,cas,woknows4,errmsg,mys3,pcx,grafika3,xms,paleta2,retezce,com,disk,nfsup,cfg;
const sirka=10; {rozmery lodi [policka]}
      vyska=10;
      velp=10; {velikost policka [px] pri zobrazeni ve hre (1:1)}

      vahakonstrukce=250;
      vahapancire=300;
      vahanadrze=200;{+obsah (0..1000)}
      vahazasobniku=350;
      vahamalehomotoru=400;
      vahavelkehomotoru=900;
      vahamalehodela=300;
      vahavelkehodela=450;
      vahakabiny=500;

      hpkonstrukce=25;
      hppancire=50;
      hpnadrze=7;
      hpzasobniku=10;
      hpmalehomotoru=10;
      hpvelkehomotoru=15;
      hpmalehodela=10;
      hpvelkehodela=15;
      _hpkabiny=10;

      silamalehomotoru=2500;
      silavelkehomotoru=10000;
      silamalehodela=1000;  {zpetne razy}
      silavelkehodela=4000;
      spotrebamalehomotoru=1;
      spotrebavelkehomotoru=5;
      spotrebamalehodela=1;
      spotrebavelkehodela=5;
      ohrevmalehodela=2;
      ohrevvelkehodela=15;
      dmgmalehodela=15;
      dmgvelkehodela=50;
      obsahnadrze=1000;
      obsahzasobniku=100;
      rychloststrel=8;

      minindexpancire=23;
      maxindexpancire=38;
      indexnadrze=13;
      indexkabiny=14;
      indexmalehomotoru=15;
      indexvelkehomotoru=16;
      indexmalehoplamene=17;
      indexvelkehoplamene=18;
      indexmalehodela=19;
      indexvelkehodela=20;
      indexzasobniku=21;

      dk=60; {delka cyklu [ms]}

      menu=0;
      stavba=1;
      ZmenaPozadi=2;
      SoloLet=3;
      DvaNaJednom=4;
      DvaPoKabelu=5;
      konec=6;
      vyhral1=7;
      vyhral2=8;
      remiza=9;
      credits=10;
      manual1=11;
      manual5=15;

      vlevo=1;    {pro umistovani meraku}
      vpravo=636;
      nalevo=50;  {pro umistovani lodi}
      napravo=590;
      uprostred=310;

      cZadnaDalsiKlavesa=255;  {prikazy pro komunikaci po kabelu}
      cJsemPrvni=254;
      cJsemDruhy=253;
      cKonecCykluMozny=252;
      cKonecCykluPotvrzen=251;
      cZadnaDalsiStrela=250;
      cPosilamLod=249;
      cMuzemeZacit=248;
      cKoncime=247;
      cVelky=246;
      cMaly=245;

      jnic=0;
      jkonstrukce=1;
      jnadrz=2;
      jzasobnik=3;
      jmalymotor=4;
      jvelkymotor=5;
      jmaledelo=6;
      jvelkedelo=7;

      tolerance=50; {o kolik musi lod vyletet z obrazovky, aby se pocitala za vyletnutou}

      {$I KSKONST.PAS}

      {ofsety souboru v ksdata2.dat:}
      ks_pal = 0;
      msdflt_fnt = 768;
      space_fnt = 2819;
      ks1_kur = 6918;
      ks_mac = 7622;
      ks2_kur = 14731;
      klic_kur = 15839;
      tlsrot_obr = 16572;
      tlsave_obr = 19475;
      tlload_obr = 21512;
      font5x5_fnt = 23465;
      obrkl_dat = 25516;

type
str40=string[40];
str8=string[8];

policko1=record {konstrukce, nadrze, zasobniky, pancire}
         HP,HPpancire:byte;
         indexpancire:byte;
         pripojeno:boolean;
         case cotoje:byte of
          jkonstrukce:(indexkonstrukce:byte);
          jnadrz,jzasobnik:(obsah:word);
         end;
pole1=array[0..vyska,0..sirka] of policko1;
policko2=record {motory, dela}
         HP:byte;
         smer:integer;
         klavesa1,klavesa2:byte;
         case cotoje:byte of
          jmalymotor,jvelkymotor:(jede:boolean);
          jmaledelo,jvelkedelo:(teplota:byte);
         end;
pole2=array[0..vyska,0..sirka] of policko2;

lod = record
      {veci, ktere se ukladaji do souboru:}
      jmeno:str40;
      Xkabiny,Ykabiny:byte;
      veci1:pole1;
      veci2:pole2;
      {veci, ktere se neukladaji:}
      HPkabiny:byte;
      palivo,strelivo,maxpaliva,maxstreliva:word;
      xT,yT:word; {souradnice teziste v lodnich souradnicich [px] vzhledem k LH rohu}
      lhx,lhy:integer; {zaokrouhlene souradnice leveho horniho rohu lode nad obrazovkou}
      vaha,J:longint; {hmotnost lodi a jeji moment setrvacnosti vzhledem k tezisti}
      x,y,uhel:single; {souradnice teziste nad obrazovkou [px] a uhel natoceni [stupnu]}
      vx,vy,omega:single; {rychlost posunu teziste po obrazovce [px/cyklus] a rotace lodi kolem teziste [stupnu/cyklus]}
      end;

uknavrak = ^vrak;
vrak = record
       troska:lod;
       dalsi:uknavrak;
       end;

uknastrelu=^strela;
strela = record
         x,y,vx,vy:single;
         sila:word;
         dalsi:uknastrelu;
         end;

const velikostlode=2+sizeof(pole1)+sizeof(pole2)+41;
      vahy:array[jnic..jvelkedelo] of word=(0,vahakonstrukce,vahanadrze,vahazasobniku,vahamalehomotoru,
                                    vahavelkehomotoru,vahamalehodela,vahavelkehodela);

var grdata:mac;
    vetsifont:_font;
    pozadi:word; {handle pro Savescr/Loadscr}
    strely:uknastrelu;
    lode:array[1..2] of lod;
    hrac:array[1..2] of string[39];{delku nemenit!!!}
    lodnisoubory:array[1..3] of str8;
    souborpozadi:str8;
    StavHry:byte;
    prvnivrak:uknavrak;
    jsem:byte; {jestli jsem pri hre po kabelu ten hlavni}
    pom:byte;
    zacykleno,epesnipristroje,muzeme,debug:boolean;
    cisloportu:byte;
    baudy:longint;
    hernipaleta:rgbpal256;
    binsoubor:file;

procedure uriznikoncovku(var cemu:str8);
var b:byte;
Begin
b:=pos('.',cemu);
if b<>0 then cemu[0]:=chr(b-1);
End;{uriznikoncovku}

procedure ZatmiCtvercem(x,y:integer);
const hranice=90;
var krok,pocetkroku:integer;
Begin
pocetkroku:=640-x;
if x>pocetkroku then pocetkroku:=x;
if 480-y>pocetkroku then pocetkroku:=480-y;
if y>pocetkroku then pocetkroku:=y;
for krok:=pocetkroku downto 1 do begin
                                 startcekani;
                                 __rectangle(x-krok,y-krok,x+krok,y+krok,0);
                                 if krok=hranice then pockej(10)
                                                 else if odd(krok) then pockej(abs(200 div (krok-hranice))+1);
                                 end;
stopcekani;
__putpixel(x,y,0);
End;{zatmictvercem}

procedure ZvazLod(var l:lod; jetovrak:boolean);
{spocita polohu teziste vzhledem k LH rohu lodi a moment setrvacnosti k tezisti}
var i,j:word;
    cu,su,iuhel:integer;
    soucetxmomentu,soucetymomentu,rnadruhou:longint;
    obspal,pocetnadrzi,pocetzasobniku:word;
    vyrobitvrak:boolean;
    novyvrak:uknavrak;
{}procedure zkontroluj(var l:lod; x,y:byte);{zjisti, jestli lod drzi pohromade}
{}Begin
{}if (not l.veci1[y,x].pripojeno)and(l.veci1[y,x].cotoje>=jkonstrukce)and(l.veci1[y,x].cotoje<=jzasobnik)
{}  then begin
{}       l.veci1[y,x].pripojeno:=true;
{}       if x>0 then zkontroluj(l,x-1,y);
{}       if x<sirka then zkontroluj(l,x+1,y);
{}       if y>0 then zkontroluj(l,x,y-1);
{}       if y<vyska then zkontroluj(l,x,y+1);
{}       end;
{}End;{zkontroluj}
Begin
soucetxmomentu:=0;
soucetymomentu:=0;
l.vaha:=0;
pocetnadrzi:=0;
pocetzasobniku:=0;
if not jetovrak then
 begin
 {kontrola celistvosti:}
 for i:=0 to vyska do for j:=0 to sirka do begin {spocitani nadrzi a zasobniku a inicializace propojenosti}
                                           if l.veci1[i,j].cotoje=jnadrz then inc(pocetnadrzi)
                                            else if l.veci1[i,j].cotoje=jzasobnik then inc(pocetzasobniku);
                                           l.veci1[i,j].pripojeno:=false;
                                           end;
 zkontroluj(l,l.xkabiny,l.ykabiny);
 vyrobitvrak:=false;
 for i:=0 to vyska do for j:=0 to sirka do
  if (l.veci1[i,j].hp<>0) and not l.veci1[i,j].pripojeno then vyrobitvrak:=true;
 if vyrobitvrak and (maxavail>=sizeof(vrak)) then
  begin
  vyrobitvrak:=false;
  new(novyvrak);
  fillchar32(novyvrak^,sizeof(vrak),0);
  for i:=0 to vyska do for j:=0 to sirka do
   if not l.veci1[i,j].pripojeno then
     begin
     novyvrak^.troska.veci1[i,j]:=l.veci1[i,j];
     fillchar32(l.veci1[i,j],sizeof(policko1),0);
     novyvrak^.troska.veci2[i,j]:=l.veci2[i,j];
     novyvrak^.troska.veci2[i,j].jede:=false;
     fillchar32(l.veci2[i,j],sizeof(policko2),0);
     end;
  with novyvrak^.troska do begin
                           x:=l.x; y:=l.y; uhel:=l.uhel;
                           vaha:=l.vaha; J:=l.J;
                           xt:=l.xt; yt:=l.yt;
                           vx:=l.vx+2*random-1; vy:=l.vy+2*random-1; omega:=l.omega+2*random-1;
                           end;
  novyvrak^.dalsi:=prvnivrak;
  prvnivrak:=novyvrak;
  end;
 end;
{teziste:}
if l.palivo>pocetnadrzi*obsahnadrze then l.palivo:=pocetnadrzi*obsahnadrze;
if l.strelivo>pocetzasobniku*obsahzasobniku then l.strelivo:=pocetzasobniku*obsahzasobniku;
if pocetnadrzi=0 then obspal:=0
                 else obspal:=l.palivo div pocetnadrzi;
for i:=0 to vyska do
 for j:=0 to sirka do begin
                      inc(soucetxmomentu,j*vahy[l.veci1[i,j].cotoje]);
                      inc(soucetymomentu,i*vahy[l.veci1[i,j].cotoje]);
                      inc(l.vaha,vahy[l.veci1[i,j].cotoje]);
                      if l.veci1[i,j].cotoje=jnadrz then begin
                                                         inc(soucetxmomentu,j*obspal);
                                                         inc(soucetymomentu,i*obspal);
                                                         inc(l.vaha,obspal);
                                                         end;
                      if l.veci1[i,j].hppancire<>0 then begin
                                                        inc(soucetxmomentu,j*vahapancire);
                                                        inc(soucetymomentu,i*vahapancire);
                                                        inc(l.vaha,vahapancire);
                                                        end;
                      inc(soucetxmomentu,j*vahy[l.veci2[i,j].cotoje]);
                      inc(soucetymomentu,i*vahy[l.veci2[i,j].cotoje]);
                      inc(l.vaha,vahy[l.veci2[i,j].cotoje]);
                      end;
if l.hpkabiny<>0 then begin
                      inc(soucetxmomentu,(l.xkabiny*word(vahakabiny)));
                      inc(soucetymomentu,(l.ykabiny*word(vahakabiny)));
                      inc(l.vaha,vahakabiny);
                      end;
iuhel:=round(l.uhel);
cu:=rychlycos(iuhel);
su:=rychlysin(iuhel);
l.x:=l.x-(l.xt*cu-l.yt*su)/10000;   {aby lod neskakala po obrazovce, kdykoli se ji posune teziste}
l.y:=l.y-(l.xt*su+l.yt*cu)/10000;
if l.vaha=0 then exit;
l.xt:=longint(velp)*soucetxmomentu div l.vaha;
l.yt:=longint(velp)*soucetymomentu div l.vaha;
l.x:=l.x+(l.xt*cu-l.yt*su)/10000;
l.y:=l.y+(l.xt*su+l.yt*cu)/10000;
{moment setrvacnosti:}
l.J:=0;
for i:=0 to vyska do for j:=0 to sirka do
 begin
 rnadruhou:=i*i+j*j;
 inc(l.J,vahy[l.veci1[i,j].cotoje]*rnadruhou);
 if l.veci1[i,j].cotoje=jnadrz then inc(l.J,obspal*rnadruhou);
 if l.veci1[i,j].hppancire<>0 then inc(l.J,vahapancire*rnadruhou);
 inc(l.J,vahy[l.veci2[i,j].cotoje]*rnadruhou);
 end;
if l.hpkabiny<>0 then inc(l.J,(longint(vahakabiny)*(word(l.xkabiny)*l.xkabiny+word(l.ykabiny)*l.ykabiny)));
l.J:=(l.J*velp*velp-l.vaha*round(l.xT*l.xT+l.yT*l.yT)) div 57;{priblizne prepocitano na stupne}
End;{zvazlod}

procedure PostrcLod(var l:lod; sila:word; smer:integer; x,y:word);
{meni rychlost pohybu a otaceni lode podle pusobici sily}
var a,s:single;
    iuhel:integer;
Begin
iuhel:=round(l.uhel);
{posun (a znamena zrychleni):}
if l.vaha=0 then exit;
a:=sila/l.vaha;
l.vx:=l.vx+a*rychlycos(smer+iuhel)/10000;
l.vy:=l.vy+a*rychlysin(smer+iuhel)/10000;
{rotace (A ted znamena moment):}
s:=sila;
A:=s*((x*integer(velp)-l.xT)*rychlysin(smer)-(y*integer(velp)-l.yT)*rychlycos(smer))/10000;
l.omega:=l.omega+A/l.J;
End;{postrclod}

procedure PresunLod(var l:lod); {upravi polohu a natoceni podle aktualnich rychlosti a vyridi pripadne vyletnuti z obrazovky}
var su,cu:longint;
Begin
with l do begin
          x:=x+vx;
          y:=y+vy;
          uhel:=uhel+omega;
          if zacykleno then begin
                            if x<-tolerance then x:=639+tolerance;
                            if y<-tolerance then y:=479+tolerance;
                            if x>639+tolerance then x:=-tolerance;
                            if y>479+tolerance then y:=-tolerance;
                            end
                       else if (x<-tolerance)or(x>639+tolerance)or(y<-tolerance)or(y>479+tolerance) then hpkabiny:=0;
          su:=rychlysin(round(uhel));
          cu:=rychlycos(round(uhel));
          lhx:=round((-xT*cu+yT*su)/10000+x);
          lhy:=round((-xT*su-yT*cu)/10000+y);
          end;
End;{presunlod}

procedure UlozLod(var l:lod; jmenoS:string); {ulozi lod do souboru}
var f:file;
Begin
assign(f,jmenos+'.LOD');
rewrite(f,velikostlode);
blockwrite(f,l,1);
close(f);
if ioresult<>0 then {kaslu na to};
End;{ulozlod}

procedure NactiLod(var l:lod; jmenoS:string); {nacte lod ze souboru}
var f:file;
Begin
fillchar32(l,velikostlode,0);
assign(f,jmenos+'.LOD');
reset(f,velikostlode);
if ioresult=0 then begin
                   blockread(f,l,1);
                   close(f);
                   l.hpkabiny:=_hpkabiny;
                   if ioresult<>0 then fillchar32(l,velikostlode,0);
                   end;
End;{nactilod}

procedure KresliLod(var l:lod); {vykresli danou lod na obrazovku}
var i,j:integer; {indexy do poli}
    xd,yd:integer; {zaokrouhlena poloha kresleneho dilu nad obrazovkou}
    iuhel:integer;
    cu,su:longint;
Begin
{nalezeni polohy LH rohu lode:}
iuhel:=round(l.uhel);
cu:=rychlycos(iuhel);
su:=rychlysin(iuhel);
{konstrukce, nadrze, zasobniky:}
for i:=0 to vyska do
 for j:=0 to sirka do begin
                      {nalezeni polohy dilu nad obrazovkou:}
                      xd:=((cu*j-su*i)*velp) div 10000+l.lhx;
                      yd:=((su*j+cu*i)*velp) div 10000+l.lhy;
                      {kresleni:}
                      case l.veci1[i,j].cotoje of jkonstrukce:kreslimac(grdata,l.veci1[i,j].indexkonstrukce,xd,yd,100,iuhel);
                                                  jnadrz:kreslimac(grdata,indexnadrze,xd,yd,100,iuhel);
                                                  jzasobnik:kreslimac(grdata,indexzasobniku,xd,yd,100,iuhel);
                                                  end;
                      end;
{plameny, motory, dela:}
for i:=0 to vyska do
 for j:=0 to sirka do
  begin
  xd:=((cu*j-su*i)*velp) div 10000+l.lhx;
  yd:=((su*j+cu*i)*velp) div 10000+l.lhy;
  case l.veci2[i,j].cotoje of jmalymotor:begin
                                         if l.veci2[i,j].jede
                                           then kreslimac(grdata,indexmalehoplamene,xd,yd,100,iuhel+l.veci2[i,j].smer);
                                         kreslimac(grdata,indexmalehomotoru,xd,yd,100,iuhel+l.veci2[i,j].smer);
                                         end;
                              jvelkymotor:begin
                                          if l.veci2[i,j].jede
                                            then kreslimac(grdata,indexvelkehoplamene,xd,yd,100,iuhel+l.veci2[i,j].smer);
                                          kreslimac(grdata,indexvelkehomotoru,xd,yd,100,iuhel+l.veci2[i,j].smer);
                                          end;
                              jmaledelo:kreslimac(grdata,indexmalehodela,xd,yd,100,iuhel+l.veci2[i,j].smer);
                              jvelkedelo:kreslimac(grdata,indexvelkehodela,xd,yd,100,iuhel+l.veci2[i,j].smer);
                              end;
  end;
{pancire:}
for i:=0 to vyska do
 for j:=0 to sirka do begin
                      xd:=((cu*j-su*i)*velp) div 10000+l.lhx;
                      yd:=((su*j+cu*i)*velp) div 10000+l.lhy;
                      if l.veci1[i,j].hppancire<>0 then kreslimac(grdata,l.veci1[i,j].indexpancire,xd,yd,100,iuhel);
                      end;
{kabina:}
if l.hpkabiny<>0 then kreslimac(grdata,indexkabiny,
                                ((cu*l.xkabiny-su*l.ykabiny)*velp) div 10000+l.lhx,
                                ((su*l.xkabiny+cu*l.ykabiny)*velp) div 10000+l.lhy,
                                100,iuhel);
End;{kreslilod}

procedure PresunStrely;{zaridi pohyb, kresleni, ucinky a likvidaci vsech strel na obrazovce}
const _tolerance=velp shr 1;
var u,u2,sm:uknastrelu;
    smazat:boolean;
    i,j:longint;
    iuhel,cu1,su1,cu2,su2,xd,yd,d:integer;
{}procedure bouchni(var doceho:byte; var cim:word);
{}Begin
{}if cim<>0 then if doceho>cim then begin
{}                                  kreslimac(grdata,22,xd,yd,3*cim+10,random(360));
{}                                  dec(doceho,cim);
{}                                  cim:=0;
{}                                  end
{}                             else if doceho<>0 then begin
{}                                                    kreslimac(grdata,22,xd,yd,3*cim+10,random(360));
{}                                                    dec(cim,doceho);
{}                                                    doceho:=0;
{}                                                    end;
{}End;{bouchni}
Begin
iuhel:=round(lode[1].uhel);
cu1:=rychlycos(iuhel);
su1:=rychlysin(iuhel);
if stavhry<>sololet then begin
                         iuhel:=round(lode[2].uhel);
                         cu2:=rychlycos(iuhel);
                         su2:=rychlysin(iuhel);
                         end;
u2:=nil;
u:=strely;
while u<>nil do
 begin
 with u^ do begin
            x:=x+vx;
            y:=y+vy;
            __filledellipse(round(x),round(y),1+sila shr 3,1+sila shr 3,11);
            dec(sila);
            {reseni kolize s lodemi:}
            for i:=0 to vyska do {prvni lod}
             begin
             if sila=0 then break;
             for j:=0 to sirka do
              begin
              if sila=0 then break;
              xd:=((cu1*j-su1*i)*velp) div 10000+lode[1].lhx;
              yd:=((su1*j+cu1*i)*velp) div 10000+lode[1].lhy;
              if (abs(x-xd)<_tolerance)and(abs(y-yd)<_tolerance)
                then begin
                     bouchni(lode[1].veci1[i,j].hppancire,sila);
                     bouchni(lode[1].veci2[i,j].hp,sila);
                     if lode[1].veci2[i,j].hp=0 then begin
                                                     lode[1].veci2[i,j].cotoje:=jnic;
                                                     lode[1].veci2[i,j].jede:=false;
                                                     end;
                     bouchni(lode[1].veci1[i,j].hp,sila);
                     if lode[1].veci1[i,j].hp=0 then lode[1].veci1[i,j].cotoje:=jnic;
                     end;
              end;
             end;
            xd:=((cu1*longint(lode[1].xkabiny)-su1*longint(lode[1].ykabiny))*velp) div 10000+lode[1].lhx;
            yd:=((su1*longint(lode[1].xkabiny)+cu1*longint(lode[1].ykabiny))*velp) div 10000+lode[1].lhy;
            if (abs(x-xd)<_tolerance)and(abs(y-yd)<_tolerance) then bouchni(lode[1].hpkabiny,sila);
            if stavhry<>sololet then for i:=0 to vyska do {druha lod}
             begin
             if sila=0 then break;
             for j:=0 to sirka do
              begin
              if sila=0 then break;
              xd:=((cu2*j-su2*i)*velp) div 10000+lode[2].lhx;
              yd:=((su2*j+cu2*i)*velp) div 10000+lode[2].lhy;
              if (abs(x-xd)<_tolerance)and(abs(y-yd)<_tolerance)
                then begin
                     bouchni(lode[2].veci1[i,j].hppancire,sila);
                     bouchni(lode[2].veci2[i,j].hp,sila);
                     if lode[2].veci2[i,j].hp=0 then begin
                                                     lode[2].veci2[i,j].cotoje:=jnic;
                                                     lode[2].veci2[i,j].jede:=false;
                                                     end;
                     bouchni(lode[2].veci1[i,j].hp,sila);
                     if lode[2].veci1[i,j].hp=0 then lode[2].veci1[i,j].cotoje:=jnic;
                     end;
              end;
             end;
            xd:=((cu2*longint(lode[2].xkabiny)-su2*longint(lode[2].ykabiny))*velp) div 10000+lode[2].lhx;
            yd:=((su2*longint(lode[2].xkabiny)+cu2*longint(lode[2].ykabiny))*velp) div 10000+lode[2].lhy;
            if (abs(x-xd)<_tolerance)and(abs(y-yd)<_tolerance) then bouchni(lode[2].hpkabiny,sila);
            smazat:=sila=0;
            if zacykleno then begin
                              if x<-tolerance then x:=639+tolerance;
                              if y<-tolerance then y:=479+tolerance;
                              if x>639+tolerance then x:=-tolerance;
                              if y>479+tolerance then y:=-tolerance;
                              end
                         else smazat:=smazat or (x<-tolerance)or(x>639+tolerance)or(y<-tolerance)or(y>479+tolerance);
            end;
 if smazat then begin
                if u2=nil then strely:=u^.dalsi
                          else u2^.dalsi:=u^.dalsi;
                sm:=u;
                u:=u^.dalsi;
                dispose(sm);
                end
           else begin
                u2:=u;
                u:=u^.dalsi;
                end;
 end;
End;{presunstrely}

procedure vystrel(odkudx,odkudy,odkudvx,odkudvy:single; smer:integer; velky,zKabelu:boolean);{vytvori novou strelu}
const bezpecnost=1;
var n:uknastrelu;
Begin
if maxavail>=sizeof(strela) then
 begin
 new(n);
 with n^ do begin
            vx:=longint(rychloststrel)*rychlycos(smer)/10000+odkudvx;
            vy:=longint(rychloststrel)*rychlysin(smer)/10000+odkudvy;
            x:=odkudx+bezpecnost*vx;
            y:=odkudy+bezpecnost*vy;
            if velky then sila:=dmgvelkehodela
                     else sila:=dmgmalehodela;
            dalsi:=strely;
            end;
 strely:=n;
 if (stavhry=dvapokabelu) and not zkabelu then begin {odeslani strely pres kabel}
                                               if velky then comtx(cvelky) else comtx(cmaly);
                                               comtxblock(odkudx,4);
                                               comtxblock(odkudy,4);
                                               comtxblock(odkudvx,4);
                                               comtxblock(odkudvy,4);
                                               comtxblock(smer,2);
                                               end;
 end;
End;{vystrel}

procedure Rizeni(var l:lod); {zpracuje vstupy z klavesnice}
var i,j:integer;
    iuhel,cu,su:integer;
Begin
iuhel:=round(l.uhel);
for i:=0 to vyska do for j:=0 to sirka do
  case l.veci2[i,j].cotoje of
   jmalymotor:if (l.palivo>=spotrebamalehomotoru)and(pressed(l.veci2[i,j].klavesa1) or pressed(l.veci2[i,j].klavesa2))
                then begin
                     l.veci2[i,j].jede:=true;
                     postrclod(l,silamalehomotoru,l.veci2[i,j].smer,j,i);
                     dec(l.palivo,spotrebamalehomotoru);
                     end
                else l.veci2[i,j].jede:=false;
   jvelkymotor:if (l.palivo>=spotrebavelkehomotoru)and(pressed(l.veci2[i,j].klavesa1)or pressed(l.veci2[i,j].klavesa2))
                 then begin
                      l.veci2[i,j].jede:=true;
                      postrclod(l,silavelkehomotoru,l.veci2[i,j].smer,j,i);
                      dec(l.palivo,spotrebavelkehomotoru);
                      end
                 else l.veci2[i,j].jede:=false;
   jmaledelo:if l.veci2[i,j].teplota<>0
               then dec(l.veci2[i,j].teplota)
               else if (l.strelivo>=spotrebamalehodela)and pressed(l.veci2[i,j].klavesa1)
                      then begin
                           cu:=rychlycos(iuhel);
                           su:=rychlysin(iuhel);
                           vystrel((((cu*longint(j)-su*longint(i))*velp)+(-l.xT*cu+l.yT*su))/10000+l.x,
                                   (((su*longint(j)+cu*longint(i))*velp)+(-l.xT*su-l.yT*cu))/10000+l.y,
                                   l.vx,l.vy,iuhel+l.veci2[i,j].smer,false,false);
                           postrclod(l,silamalehodela,l.veci2[i,j].smer+180,j,i);
                           l.veci2[i,j].teplota:=ohrevmalehodela;
                           dec(l.strelivo,spotrebamalehodela);
                           end;
   jvelkedelo:if l.veci2[i,j].teplota<>0
                then dec(l.veci2[i,j].teplota)
                else if (l.strelivo>=spotrebavelkehodela)and pressed(l.veci2[i,j].klavesa1)
                       then begin
                            cu:=rychlycos(iuhel);
                            su:=rychlysin(iuhel);
                            vystrel((((cu*longint(j)-su*longint(i))*velp)+(-l.xT*cu+l.yT*su))/10000+l.x,
                                    (((su*longint(j)+cu*longint(i))*velp)+(-l.xT*su-l.yT*cu))/10000+l.y,
                                    l.vx,l.vy,iuhel+l.veci2[i,j].smer,true,false);
                            postrclod(l,silavelkehodela,l.veci2[i,j].smer+180,j,i);
                            l.veci2[i,j].teplota:=ohrevvelkehodela;
                            dec(l.strelivo,spotrebavelkehodela);
                            end;
  end;
if muzeme and pressed(pF4) then screenshot;
if muzeme and pressed(pF5) then epesnipristroje:=not epesnipristroje;
if muzeme and pressed(pF6) then debug:=not debug;
muzeme:=not(pressed(pF4) or pressed(pF5) or pressed(pF6));
if (stavhry<>dvanajednom) and pressed(pF10) then l.hpkabiny:=0;
if stavhry=dvapokabelu then comtx(czadnadalsistrela);
End;{rizeni}

procedure OdesliLod(var l:lod); {odesle pres kabel parametry lode a stisknute klavesy}
var i:integer;
Begin
i:=round(l.uhel);
comtxblock(i,2);
comtxblock(l.x,4);
comtxblock(l.y,4);
comtxblock(l.vx,4);
comtxblock(l.vy,4);
comtxblock(l.omega,4);
for i:=1 to 254 do if pressed(i) then comtx(i);
comtx(czadnadalsiklavesa);
End;{odeslilod}

procedure KabeloveRizeniAPresun(var l:lod); {zpracuje vstupy z druheho pocitace}
var i,j:byte;
    iuhel,cu,su:integer;
    pressed:array[0..255] of boolean; {emulovana klavesnice}
    odkudx,odkudy,odkudvx,odkudvy:single;
Begin
{prijem strel:}
i:=comrx;
while i<>czadnadalsistrela do begin
                              comrxblock(odkudx,4);
                              comrxblock(odkudy,4);
                              comrxblock(odkudvx,4);
                              comrxblock(odkudvy,4);
                              comrxblock(iuhel,2);
                              vystrel(odkudx,odkudy,odkudvx,odkudvy,iuhel,i=cvelky,true);
                              i:=comrx;
                              end;
{prijem lode:}
comrxblock(iuhel,2);
l.uhel:=iuhel;
comrxblock(l.x,4);
comrxblock(l.y,4);
comrxblock(l.vx,4);
comrxblock(l.vy,4);
comrxblock(l.omega,4);
{vypocty:}
su:=rychlysin(iuhel);
cu:=rychlycos(iuhel);
l.lhx:=round((-l.xT*cu+l.yT*su)/10000+l.x);
l.lhy:=round((-l.xT*su-l.yT*cu)/10000+l.y);
{klavesy:}
fillchar32(pressed,256,0);
 repeat
 i:=comrx;
 pressed[i]:=true;
 until i=czadnadalsiklavesa;
for i:=0 to vyska do for j:=0 to sirka do
  if (l.veci2[i,j].cotoje=jmalymotor)or(l.veci2[i,j].cotoje=jvelkymotor)
    then l.veci2[i,j].jede:=pressed[l.veci2[i,j].klavesa1] or pressed[l.veci2[i,j].klavesa2];
if pressed[1] then stavhry:=menu;
End;{kabeloverizeniapresun}

procedure KrL(var l:lod; lhx,lhy:word; skryjpancir:boolean);{vykresli lod v meritku 200%}
var i,j:integer;
Begin
{konstrukce, nadrze, zasobniky:}
for i:=0 to vyska do for j:=0 to sirka do
 case l.veci1[i,j].cotoje of
  jkonstrukce:kreslimac(grdata,l.veci1[i,j].indexkonstrukce,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,0);
  jnadrz:kreslimac(grdata,indexnadrze,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,0);
  jzasobnik:kreslimac(grdata,indexzasobniku,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,0);
  end;
{motory, dela:}
for i:=0 to vyska do for j:=0 to sirka do
 case l.veci2[i,j].cotoje of jmalymotor:kreslimac(grdata,indexmalehomotoru,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,
                                                  l.veci2[i,j].smer);
                             jvelkymotor:kreslimac(grdata,indexvelkehomotoru,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,
                                                   l.veci2[i,j].smer);
                             jmaledelo:kreslimac(grdata,indexmalehodela,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,
                                                 l.veci2[i,j].smer);
                             jvelkedelo:kreslimac(grdata,indexvelkehodela,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,
                                                  l.veci2[i,j].smer);
                             end;
{pancire:}
if not skryjpancir then
 for i:=0 to vyska do for j:=0 to sirka do
  if l.veci1[i,j].indexpancire<>0 then kreslimac(grdata,l.veci1[i,j].indexpancire,lhx+velp*2*j+velp,lhy+velp*2*i+velp,200,0);
{kabina:}
if l.hpkabiny<>0 then kreslimac(grdata,indexkabiny,lhx+velp*2*l.xkabiny+velp,lhy+velp*2*l.ykabiny+velp,200,0);
End;{krl}

procedure UkazOvladani(var l:lod; cislolode:byte);{kompletni rozhrani pro predvadeni ovladacich klaves}
label nic;
const zobrklx=35;   {levy horni roh zobrazovane klavesnice}
      zobrkly=320;
      posledni=16+21+21+16+17+10; {index posledni klavesy}
      lhx=70; {l. h. roh zobrazovane lode}
      lhy=40;
var mensifont:_font;
    klx,kly:array[1..posledni] of integer; {souradnice klaves}
    kls,klv,sck:array[1..posledni] of byte; {sirky, vysky a scankody klaves}
    klt:array[1..posledni] of string[5]; {texty na klavesach}
    index:byte;{index naposledy kreslene klavesy (vyrazne urychli vyhledavani nasledujicich scankodu)}
    propojeno:byte; {0 = nic, 1 = od klavesnice, 2 = od lode}
    propscankod,propi,propj:byte; {parametry aktualnich spojnic}
    i,j,k:byte;
    ukazmotz,ukazzbrz:zatrzitko;
{}procedure ZobrazKlavesu(scankod,styl:word);
{}var odzacatku:boolean;
{}    lhb,pdb,vb:word;{barvy}
{}Begin
{}{nalezeni indexu:}
{}if scankod>$8000
{}  then index:=scankod and $7FFF
{}  else begin
{}       odzacatku:=index=1;
{}       scankod:=scankod and $7FFF;
{}        repeat
{}        while (index<=posledni)and(scankod<>sck[index]) do inc(index);
{}        if scankod=sck[index] then break;
{}        if (index>posledni)and odzacatku then exit {neexistujici scankod}
{}                                         else begin {projizdime znovu}
{}                                              odzacatku:=true;
{}                                              index:=1;
{}                                              end;
{}        until false; {ukoncuje se breakem nebo exitem}
{}       end;
{}{barvy:}
{}case styl of 0:begin lhb:=15; pdb:=8; vb:=7 shl 8 or 7; end;
{}             1:begin lhb:=14; pdb:=39; vb:=43 shl 8 or 43; end;
{}             2:begin lhb:=13; pdb:=34; vb:=35 shl 8 or 35; end;
{}             3:begin lhb:=14; pdb:=34; vb:=43 shl 8 or 35; end;
{}             end;
{}{vykresleni:}
{}__maskedbox(zobrklx+klx[index],zobrkly+kly[index],zobrklx+klx[index]+kls[index]-1,zobrkly+kly[index]+klv[index]-1,
{}            lhb,pdb,vb,_sikmepruhy);
{}_print(zobrklx+klx[index]+3,zobrkly+kly[index]+5,0,klt[index]);
{}End;{zobrazklavesu}
{}procedure ZobrazKlavesnici;
{}const ns=23; {normalni sirka}
{}      nvr=ns+2; {normalni vodorovna roztec}
{}      nv=20; {vyska}
{}      nsr=22; {normalni svisla roztec}
{}var i:byte;
{}Begin
{}{zakladni deska:}
{}_box(zobrklx-10,zobrkly-10,zobrklx+584,zobrkly+6*nsr+20,15,8,7);
{}{vyrezy okolo skupin klaves:}
{}_box(zobrklx-5,zobrkly+nsr+6,zobrklx+15*nvr-3,zobrkly+6*nsr+11,8,15,0);{alfanumericka cast}
{}_box(zobrklx+19*nvr-5,zobrkly+nsr+6,zobrklx+577,zobrkly+6*nsr+11,8,15,0);{numericka cast}
{}_box(zobrklx+15*nvr+5,zobrkly+4*nsr+6,zobrklx+18*nvr+12,zobrkly+6*nsr+11,8,15,0);{sipky}
{}_box(zobrklx+15*nvr+5,zobrkly+nsr+6,zobrklx+18*nvr+12,zobrkly+3*nsr+11,8,15,0);{klavesy nad sipkami}
{}_box(zobrklx-5,zobrkly-4,zobrklx+nvr+2,zobrkly+nsr+1,8,15,0);{esc}
{}_box(zobrklx+nvr+10,zobrkly-4,zobrklx+5*nvr+17,zobrkly+nsr+1,8,15,0);{F1..F4}
{}_box(zobrklx+6*nvr,zobrkly-4,zobrklx+10*nvr+7,zobrkly+nsr+1,8,15,0);{F5..F8}
{}_box(zobrklx+10*nvr+15,zobrkly-4,zobrklx+15*nvr-3,zobrkly+nsr+1,8,15,0);{F9..F12}
{}_box(zobrklx+15*nvr+5,zobrkly-4,zobrklx+18*nvr+12,zobrkly+nsr+1,8,15,0);{printscreen..break}
{}{kontrolky (rozsvicene podle aktualniho stavu locku):}
{}_box(zobrklx+19*nvr-5,zobrkly-4,zobrklx+577,zobrkly+nsr+1,8,15,0);
{}_print(zobrklx+19*nvr+1,zobrkly,0,'NUM   CAPS  SCRL');
{}i:=10*ord(numlock) or 8;
{}_box(zobrklx+19*nvr+5,zobrkly+12,zobrklx+19*nvr+13,zobrkly+17,0,0,i);
{}i:=10*ord(capslock) or 8;
{}_box(zobrklx+19*nvr+5+38,zobrkly+12,zobrklx+19*nvr+13+38,zobrkly+17,0,0,i);
{}i:=10*ord(scrolllock) or 8;
{}_box(zobrklx+19*nvr+5+2*38,zobrkly+12,zobrklx+19*nvr+13+2*38,zobrkly+17,0,0,i);
{}for i:=1 to posledni do zobrazklavesu(i or $8000,0);
{}End;{zobrazklavesnici}
{}procedure ZvyrazniKlavesy;
{}var i,j,k,s:byte;
{}Begin
{}for k:=2 to 255 do{pro kazdy scankod}
{} begin
{} s:=0;
{} for i:=0 to vyska do
{}  for j:=0 to sirka do
{}   if (l.veci2[i,j].klavesa1=k)or(l.veci2[i,j].klavesa2=k)
{}     then case l.veci2[i,j].cotoje of
{}           jmalymotor,jvelkymotor:if ukazmotz.hodnota then s:=s or 1;
{}           jmaledelo,jvelkedelo:if ukazzbrz.hodnota then s:=s or 2;
{}           end;
{} if s<>0 then zobrazklavesu(k,s);
{} end;
{}End;{zvyrazniklavesy}
{}procedure propoj(x,y,scankod:byte);{kresli spojnici mezi polickem lode a klavesou}
{}var k:byte;
{}Begin
{}k:=2;
{}while (k<=posledni)and(sck[k]<>scankod) do inc(k);
{}if k<=posledni then begin
{}                    kvyp;
{}                    _xorbar(lhx+2*velp*x,lhy+2*velp*y,lhx+2*velp*x+2*velp,lhy+2*velp*y+2*velp,15);
{}                    __xorthickline(lhx+2*velp*x+velp,lhy+2*velp*y+velp,
{}                                   zobrklx+klx[k]+kls[k] shr 1,zobrkly+kly[k]+klv[k] shr 1,3,y+5);
{}                    kzap;
{}                    end;
{}End;{propoj}
{}function KlavesaSedi(x,y,scankod:byte):boolean;
{}Begin
{}klavesasedi:=((ukazmotz.hodnota and ((l.veci2[y,x].cotoje=jmalymotor)
{}              or (l.veci2[y,x].cotoje=jvelkymotor))) or
{}             (ukazzbrz.hodnota and ((l.veci2[y,x].cotoje=jmaledelo)
{}              or (l.veci2[y,x].cotoje=jvelkedelo))))
{}              and
{}             ((l.veci2[y,x].klavesa1=scankod) or
{}             (l.veci2[y,x].klavesa2=scankod));
{}End;{klavesasedi}
Begin
index:=1;
reset(binsoubor,1);
seek(binsoubor,font5x5_fnt);
_nactifont(mensifont,binsoubor);
blockread(binsoubor,klx,sizeof(klx));
blockread(binsoubor,kly,sizeof(kly));
blockread(binsoubor,kls,sizeof(kls));
blockread(binsoubor,klv,sizeof(klv));
blockread(binsoubor,klt,sizeof(klt));
blockread(binsoubor,sck,sizeof(sck));
close(binsoubor);
if ioresult<>0 then begin
                    okokno(wt.dej(ksobrklchyba));
                    exit;
                    end;
kvyp;
_nastavstrankovani;
_fill2(0);
for i:=1 to 60 do begin
                  _putpixel(random(640),random(480),15);
                  _putpixel(random(640),random(480),7);
                  _putpixel(random(640),random(480),8);
                  end;
nactilod(l,lodnisoubory[cislolode]);
krl(l,lhx,lhy,true);
for i:=0 to 14 do _print(350,10+18*i,2,wt.dej(ksukazovltext+i));
_print(40,290,2,wt.dej(kszvyrazniklavesy));
ukazmotz.init(240,290,wt.dej(ksukazmot),wt.dej(ksukazmothelp),true);
ukazzbrz.init(340,290,wt.dej(ksukazzbr),wt.dej(ksukazzbrhelp),true);
kvyp;
_nastavfont(mensifont,true);
zobrazklavesnici;
zvyrazniklavesy;
_swap; _nastavstrankovani;
{ted je tohle vsechno vykresleno na jine strance nez hlavni menu, ktere zustalo v puvodnim stavu}
kzap;
resetuj;
propojeno:=0;
 repeat
 cekejnacokoli;
 {ukazuje na klavesnici?}
 if ymys>317 then for k:=2 to posledni do
  if mysvpoli(zobrklx+klx[k],zobrkly+kly[k],zobrklx+klx[k]+kls[k],zobrkly+kly[k]+klv[k])
    then begin {ukazuje na klavesu k}
         if propojeno=1 then if propscankod=sck[k]
                               then break {ukazuje porad na stejnou, nic se nedeje}
                               else begin {preskocil primo z klavesy na klavesu}
                                    for i:=0 to vyska do for j:=0 to sirka do
                                     if klavesasedi(j,i,propscankod) then propoj(j,i,propscankod);
                                    end;
         propojeno:=1; propscankod:=sck[k];
         for i:=0 to vyska do for j:=0 to sirka do
          if klavesasedi(j,i,propscankod) then propoj(j,i,propscankod);
         end
    else {je mimo klavesu k}
         if (propojeno=1)and(propscankod=sck[k])
           then begin {zrusit propojeni}
                for i:=0 to vyska do for j:=0 to sirka do
                 if klavesasedi(j,i,propscankod) then propoj(j,i,propscankod);
                propojeno:=0;
                end;
 {ukazuje na lod?}
 if mysvpoli(lhx,lhy,lhx+sirka*velp*2+velp*2-1,lhy+vyska*velp*2+velp*2-1)
   then begin
        j:=(xmys-lhx) div (velp*2);
        i:=(ymys-lhy) div (velp*2);
        if propojeno=2 then if (propj=j)and(propi=i)
                               then goto nic {ukazuje porad na stejne policko, nic se nedeje}
                               else begin {preskocil z jednoho policka na druhe}
                                    propscankod:=l.veci2[propi,propj].klavesa1;
                                    if klavesasedi(propj,propi,propscankod) then propoj(propj,propi,propscankod);
                                    if (l.veci2[propi,propj].klavesa2<>propscankod)
                                       and klavesasedi(propj,propi,l.veci2[propi,propj].klavesa2)
                                      then propoj(propj,propi,l.veci2[propi,propj].klavesa2);
                                    end;
        propojeno:=2; propj:=j; propi:=i;
        propscankod:=l.veci2[i,j].klavesa1;
        if klavesasedi(j,i,propscankod) then propoj(j,i,propscankod);
        if (l.veci2[i,j].klavesa2<>propscankod) and
           klavesasedi(j,i,l.veci2[i,j].klavesa2)
          then propoj(j,i,l.veci2[i,j].klavesa2);
        nic:
        end
   else {je mimo lod}
        if propojeno=2 then begin
                            propscankod:=l.veci2[propi,propj].klavesa1;
                            if klavesasedi(propj,propi,propscankod) then propoj(propj,propi,propscankod);
                            if (l.veci2[propi,propj].klavesa2<>propscankod)
                               and klavesasedi(propj,propi,l.veci2[propi,propj].klavesa2)
                              then propoj(propj,propi,l.veci2[propi,propj].klavesa2);
                            propojeno:=0;
                            end;
 ukazmotz.kontrola; ukazzbrz.kontrola;
 if ukazmotz.zmeneno or ukazzbrz.zmeneno then begin kvyp; zobrazklavesnici; zvyrazniklavesy; kzap; end;
 until kliknuto or keypressed;
kvyp;
_zrusfont(mensifont); _nastavfont(vetsifont,true);
_nastavstrankovani; _swap; _nastavstrankovani; {zpet na menu}
kzap;
End;{ukazovladani}

procedure Editor;
const lhx=70; lhy=70; {levy horni roh mrizky s lodi}
      vpx=10; vpy=350; velvybp=50; {poloha vybernicku pancire a velikost jeho policek}
      vux=80; vuy=400; vur1=45; vur2=60; {nastavovadlo uhlu}
      ix=430; iy=340; roztec=16; {popisky vpravo dole}
var i,j:integer;
    vyber:prepinac;
    kl1t,kl2t,vyberlt,soubort,konect,ovladanit:tlacitko;
    srott,savet,loadt:tlacitko2;
    skryjpancz:zatrzitko;
    k:byte;
    w:word;
    vybpanc:hotspot;
    vybranypancir:byte;
    ul,up,uh,ud:tlacitko; utp:textovepole; {nastavovadlo uhlu}
    vybranyuhel:integer;
    vybranex,vybraney:byte;
    jmenotp:textovepole;
    l:lod;
    soubor,tmp:string[8];
    k2:tkurzor;
{}procedure Mrizka;{vymaze puvodni lod a nakresli mrizku}
{}var i,j:integer;
{}Begin
{}_bar(lhx-velp*2,lhy-velp*2,lhx+(sirka+2)*velp*2,lhy+(vyska+2)*velp*2,0);
{}for i:=0 to vyska+1 do _hline(lhx,lhx+velp*2*(sirka+1),lhy+velp*2*i,6);
{}for j:=0 to sirka+1 do _vline(lhx+velp*2*j,lhy,lhy+velp*2*(vyska+1),6);
{}End;{mrizka}
{}procedure zrus(var l:lod; i,j:byte); {na danem policku vymaze vsechno krome konstrukce a pancire}
{}Begin
{}if l.veci1[i,j].cotoje<>jkonstrukce then l.veci1[i,j].cotoje:=jnic;
{}l.veci2[i,j].cotoje:=jnic;
{}if (l.xkabiny=j)and(l.ykabiny=i) then l.hpkabiny:=0;
{}End;{zrus}
{}procedure VyresKonstrukci(var l:lod); {dosadi indexy bloku, aby konstrukce navazovala}
{}var i,j,k:byte;
{}Begin
{}for i:=0 to vyska do for j:=0 to sirka do
{} if l.veci1[i,j].cotoje=jkonstrukce
{}   then begin
{}        k:=0;
{}        if (j<sirka)and(l.veci1[i,j+1].cotoje<>jnic) then inc(k,2);
{}        if (j>0)and(l.veci1[i,j-1].cotoje<>jnic) then inc(k);
{}        if (i>0)and(l.veci1[i-1,j].cotoje<>jnic) then inc(k,4);
{}        if (i<vyska)and(l.veci1[i+1,j].cotoje<>jnic) then inc(k,8);
{}        case k of 15:l.veci1[i,j].indexkonstrukce:=1;
{}                  7:l.veci1[i,j].indexkonstrukce:=11;
{}                  13:l.veci1[i,j].indexkonstrukce:=10;
{}                  11:l.veci1[i,j].indexkonstrukce:=9;
{}                  14:l.veci1[i,j].indexkonstrukce:=8;
{}                  6:l.veci1[i,j].indexkonstrukce:=7;
{}                  5:l.veci1[i,j].indexkonstrukce:=6;
{}                  9:l.veci1[i,j].indexkonstrukce:=5;
{}                  10:l.veci1[i,j].indexkonstrukce:=4;
{}                  12,4,8:l.veci1[i,j].indexkonstrukce:=3;
{}                  else l.veci1[i,j].indexkonstrukce:=2;
{}                  end;
{}        end;
{}End;{vyreskonstrukci}
{}function zadejklavesu(kolikatou:byte):byte; {necha uzivatele stisknout klavesu a vrati jeji scankod}
{}var i:byte;
{}    vyzva1,vyzva2:str40;
{}    ok:okno;
{}Begin
{}initklav;
{}ok.init(210,250,246,54,wt.dej(ksnastaveniovladani));
{}vyzva1:=wt.dej(ksstiskni);
{}if kolikatou=0 then begin
{}                    vyzva1:=vyzva1+wt.dej(ksklavesukterou);
{}                    vyzva2:=wt.dej(kschcesjakospoust);
{}                    end
{}               else begin
{}                    if kolikatou=1 then vyzva1:=vyzva1+wt.dej(ksprvni)
{}                                   else vyzva1:=vyzva1+wt.dej(ksdruhou);
{}                    vyzva1:=vyzva1+wt.dej(ksklavesukterou);
{}                    vyzva2:=wt.dej(kschcesmotorzapinat);
{}                    end;
{}_print(ok.x+4,ok.y2+2,11,vyzva1);
{}_print(ok.x+4,ok.y2+17,11,vyzva2);
{} repeat
{}  repeat until not pkeypressed;
{}  repeat until pkeypressed;
{} for i:=1 to 254 do if pressed(i) and (i<>pzapnutynumlock) then begin
{}                                                                zadejklavesu:=i;
{}                                                                break;
{}                                                                end;
{} until not (i in [pEsc,pF4,pF5,pF6]);
{}ok.zrus;
{}repeat until not pkeypressed;
{}zrusklav;
{}End;{zadejklavesu}
{}procedure ZobrazVyberPancire;
{}var i:word;
{}Begin
{}for i:=0 to 2 do _hline(vpx,vpx+velvybp*8,vpy+velvybp*i,1);
{}for i:=0 to 8 do _vline(vpx+velvybp*i,vpy,vpy+velvybp*2,1);
{}_bar(vpx+velvybp*((vybranypancir-minindexpancire) and 7),
{}     vpy+velvybp*((vybranypancir-minindexpancire) shr 3),
{}     vpx+velvybp*((vybranypancir-minindexpancire) and 7)+velvybp,
{}     vpy+velvybp*((vybranypancir-minindexpancire) shr 3)+velvybp,3);
{}for i:=minindexpancire to maxindexpancire do
{} kreslimac(grdata,i,vpx+velvybp shr 1+velvybp*((i-minindexpancire) and 7),
{}           vpy+velvybp shr 1+velvybp*((i-minindexpancire) shr 3),100,0);
{}End;{zobrazvyberpancire}
{}procedure KontrolaPancire; {zaridi interakci vybernicku pancire s uzivatelem}
{}Begin
{}vybpanc.kontrola;
{}if vybpanc.hodnota=1 then begin
{}                          vybranypancir:=minindexpancire+8*(vybpanc.ykliku div velvybp)+vybpanc.xkliku div velvybp;
{}                          kvyp;
{}                          with vybpanc do _bar(a,b,c,d,0);
{}                          zobrazvyberpancire;
{}                          kzap;
{}                          end;
{}End;{kontrolapancire}
{}procedure ZobrazVyberUhlu;
{}Begin
{}kvyp;
{}_filledellipse(vux,vuy,vur2,vur2,3);
{}_filledellipse(vux,vuy,vur1,vur1,0);
{}case vyber.hodnota of 6:kreslimac(grdata,15,vux,vuy,200,vybranyuhel);
{}                      7:kreslimac(grdata,16,vux,vuy,200,vybranyuhel);
{}                      8:kreslimac(grdata,19,vux,vuy,200,vybranyuhel);
{}                      9:kreslimac(grdata,20,vux,vuy,200,vybranyuhel);
{}                      end;
{}_hline(vux-vur1,vux+vur1,vuy,11);
{}_vline(vux,vuy-vur1,vuy+vur1,11);
{}_line(vux,vuy,vux+(longint(vur2)*rychlycos(vybranyuhel))div 10000,vuy+(longint(vur2)*rychlysin(vybranyuhel))div 10000,11);
{}_nastavfont(wokfont,true);
{}ul.zobraz; up.zobraz; uh.zobraz; ud.zobraz; utp.zobraz;
{}_nastavfont(vetsifont,true);
{}End;{zobrazvyberuhlu}
{}procedure KontrolaUhlu;
{}{}procedure nastav(kolik:integer);
{}{}Begin
{}{}vybranyuhel:=kolik;
{}{}utp.hodnota:=nastr(kolik);
{}{}zobrazvyberuhlu;
{}{}End;{nastav}
{}Begin{kontrolauhlu}
{}ul.kontrola;
{}up.kontrola;
{}uh.kontrola;
{}ud.kontrola;
{}_nastavfont(wokfont,true); utp.kontrola; _nastavfont(vetsifont,true);
{}if utp.zmeneno then begin vybranyuhel:=valf(utp.hodnota,vybranyuhel); zobrazvyberuhlu; end;
{}if ul.hodnota=1 then nastav(180)
{} else if up.hodnota=1 then nastav(0)
{}  else if uh.hodnota=1 then nastav(270)
{}   else if ud.hodnota=1 then nastav(90)
{}    else if vzdalbodu(xmys,ymys,vux,vuy)<=vur2
{}           then if lmys then nastav(round(uhelpruvodice(xmys-vux,ymys-vuy)*180/pi))
{}                        else if pmys then infokno(xmys,ymys,wt.dej(ksuhelhelp),true);
{}End;{kontrolauhlu}
{}procedure UkazVyber;
{}Begin
{}_xorbar(lhx+velp*2*vybranex,lhy+velp*2*vybraney,lhx+velp*2*vybranex+2*velp,lhy+velp*2*vybraney+2*velp,15);
{}End;{ukazvyber}
{}procedure ZobrazPodrobnosti(x,y:byte);
{}var t:str40;
{}Begin
{}kvyp;
{}if (x<>vybranex)or(y<>vybraney) then
{} begin
{} if vybranex<>255 then ukazvyber; {smazani puvodniho}
{} vybranex:=x; vybraney:=y;
{} ukazvyber;{nakresleni noveho}
{} end;
{}_bar(0,320,425,479,0);
{}case l.veci2[vybraney,vybranex].cotoje of
{} jmalymotor,jvelkymotor:begin
{}                        t:=wt.dej(ksnultyscankod+l.veci2[vybraney,vybranex].klavesa1);
{}                        if t='' then t:='#'+nastr(l.veci2[vybraney,vybranex].klavesa1);
{}                        _print(kl1t.x-225,kl1t.y+2,15,wt.dej(ks1klavesa)+t);
{}                        t:=wt.dej(ksnultyscankod+l.veci2[vybraney,vybranex].klavesa2);
{}                        if t='' then t:='#'+nastr(l.veci2[vybraney,vybranex].klavesa2);
{}                        _print(kl2t.x-225,kl2t.y+2,15,wt.dej(ks2klavesa)+t);
{}                        kl1t.zobraz;
{}                        kl2t.zobraz;
{}                        end;
{} jmaledelo,jvelkedelo:begin
{}                      _print(kl1t.x-225,kl1t.y+2,15,
{}                             wt.dej(ksspoust)+wt.dej(ksnultyscankod+l.veci2[vybraney,vybranex].klavesa1));
{}                      kl1t.zobraz;
{}                      end;
{} else begin
{}      _print(5,400,7,wt.dej(nenicopredefinovavat));
{}      kzap;
{}      end;
{} end;
{}End;{zobrazpodrobnosti}
{}procedure KontrolaPodrobnosti;
{}Begin
{}if l.veci2[vybraney,vybranex].cotoje>=jmalymotor
{}  then begin
{}       kl1t.kontrola;
{}       if l.veci2[vybraney,vybranex].cotoje<=jvelkymotor then kl2t.kontrola;
{}       end;
{}if kl1t.hodnota=1 then begin
{}                      l.veci2[vybraney,vybranex].klavesa1:=zadejklavesu(ord(l.veci2[vybraney,vybranex].cotoje<=jvelkymotor));
{}                       kl1t.hodnota:=0;
{}                       zobrazpodrobnosti(vybranex,vybraney);
{}                       end;
{}if kl2t.hodnota=1 then begin
{}                       l.veci2[vybraney,vybranex].klavesa2:=zadejklavesu(2);
{}                       kl2t.hodnota:=0;
{}                       zobrazpodrobnosti(vybranex,vybraney);
{}                       end;
{}End;{kontrolapodrobnosti}
{}function UhelOK(odkudX,odkudY,uhel:integer; velky:boolean):boolean;{zkontroluje, jestli tryska nemiri dovnitr lode}
{}var cu,su,x,y:integer;
{}    t:longint;
{}    i,j,tolerance:word;
{}Begin
{}tolerance:=velp shr 1+2;
{}t:=tolerance+5;
{}if velky then begin inc(tolerance,3); inc(t,velp+4); end;
{}uhelok:=true; inc(uhel,180);
{}cu:=rychlycos(uhel); su:=rychlysin(uhel);
{} repeat
{} inc(t);
{} x:=odkudx*velp+(cu*t)div 10000;
{} y:=odkudy*velp+(su*t)div 10000;
{} if (x<0)or(x>velp*sirka)or(y<0)or(y>velp*vyska) then break;
{} for i:=0 to vyska do for j:=0 to sirka do
{}  if (abs(x-j*velp)<tolerance)and(abs(y-i*velp)<tolerance)and(l.veci1[i,j].cotoje<>jnic)
{}    then begin {kolize}
{}         kvyp; _nastavtext(3,2,0); stintext(lhx+j*velp*2-2,lhy+i*velp*2-4,12,0,2,'!'); _nastavtext(1,1,0); kzap;
{}         uhelok:=false;
{}         exit;
{}         end;
{} until false; {ukoncuje se breakem nebo exitem}
{}End;{uhelok}
{}procedure prekresli;
{}Begin
{}kvyp; mrizka; krl(l,lhx,lhy,skryjpancz.hodnota); jmenotp.zobraz;
{}End;{prekresli}
{}procedure VypisSoubor;
{}Begin
{}kvyp;
{}if soubor='' then napis(soubort.x+soubort.sirka+15,soubort.y+4,12,0,wt.dej(kszadnysoubor))
{}             else napis(soubort.x+soubort.sirka+15,soubort.y+4,14,0,zarovnej(soubor,8,_doleva,' '));
{}kzap;
{}End;{vypissoubor}
Begin{editor}
stavhry:=menu;
reset(binsoubor,1);
if ioresult<>0 then begin okokno(wt.dej(kschybidata2)); exit; end;
seek(binsoubor,klic_kur);
nactikurzor(k2,binsoubor);
nactiobrazky(srott.obrazky,binsoubor);
nactiobrazky(savet.obrazky,binsoubor);
nactiobrazky(loadt.obrazky,binsoubor);
close(binsoubor); if ioresult<>0 then {uzivatel to pozna :-)};
nastavkurzor(k2);
vybranypancir:=minindexpancire+6; vybranyuhel:=0; vybranex:=255; vybraney:=255;
scroff;
_nastavfont(wokfont,true);
ul.init(vux-vur2-16,vuy-6,#27,wt.dej(ksdoleva),0);
up.init(vux+vur2+2,vuy-6,#26,wt.dej(ksdoprava),0);
uh.init(vux-6,vuy-vur2-16,#24,wt.dej(ksnahoru),0);
ud.init(vux-6,vuy+vur2+2,#25,wt.dej(ksdolu),0);
utp.init(vux-vur2-16,vuy+vur2+2,3,nastr(vybranyuhel),false,true);
kl1t.init(250,370,wt.dej(kspredefinovat),wt.dej(kspredefhelp),2);
kl2t.init(250,410,wt.dej(kspredefinovat),wt.dej(kspredefhelp),2);
kvyp;
kreslimac(grdata,39,0,0,100,0);
mrizka;
_nastavfont(vetsifont,true);
for w:=0 to 5 do _print(10,340+20*w,2,wt.dej(ksuvodeditoru+w));
jmenotp.init(10,8,40,'',false,false);
vyber.init(370,30,wt.dej(kssoucastky),wt.dej(ksseznamdilu),wt.dej(kshelpsoucastky),1);
savet.init(576,14,wt.dej(kssavehelp));
loadt.init(576,80,wt.dej(ksloadhelp));
srott.init(576,170,wt.dej(kssrothelp));
soubort.init(416,294,wt.dej(kssoubor),wt.dej(kssouborhelp),1);
konect.init(540,240,wt.dej(kskoneceditoru),wt.dej(kskoneceditoruhelp),0);
skryjpancz.init(370,228,wt.dej(ksskryjpancir),wt.dej(ksskryjpanchelp),false);
ovladanit.init(380,256,wt.dej(ksukazovladani),wt.dej(ksukazovlhelp),0);
vybpanc.init(vpx,vpy,vpx+velvybp*8,vpy+velvybp*2,true,'');
scron;
soubor:=vybersouborokno(wt.dej(ksnadpisvyberulode),'LOD','.');
uriznikoncovku(soubor);
vypissoubor;
nactilod(l,soubor);
jmenotp.hodnota:=l.jmeno;
prekresli;
resetuj;
 repeat
 w:=0;
 cekej;
 vyber.kontrola;
 savet.kontrola; loadt.kontrola; srott.kontrola; soubort.kontrola;
 jmenotp.kontrola; skryjpancz.kontrola; konect.kontrola; ovladanit.kontrola;
 if vyber.hodnota=5 then kontrolapancire
  else if (vyber.hodnota>=6)and(vyber.hodnota<=9) then kontrolauhlu
   else if vyber.hodnota=10 then kontrolapodrobnosti;
 if vyber.zmeneno then begin
                       kvyp;
                       _bar(0,320,639,479,0);
                       if (vybranex<>255)and(vyber.hodnota<>10) then begin
                                                                     ukazvyber;
                                                                     vybranex:=255;
                                                                     end;
                       case vyber.hodnota of 5:zobrazvyberpancire;
                                             6..9:zobrazvyberuhlu;
                                             10:if vybranex<>255 then ukazvyber;
                                             end;
                       for w:=0 to 6 do {informace o vybranem dilu}
                        _print(ix,iy+roztec*w,2,wt.dej(ksprvnipopis+(vyber.hodnota-1)*7+w));
                       kzap;
                       end;
 if (srott.hodnota=1) and anoneokno(wt.dej(ksdotazsrot)) then begin
                                                              fillchar32(l,sizeof(l),0);
                                                              l.hpkabiny:=0;
                                                              mrizka; krl(l,lhx,lhy,skryjpancz.hodnota);
                                                              end;
 if skryjpancz.zmeneno then prekresli;
 if ovladanit.hodnota=1 then begin
                             lodnisoubory[3]:=soubor;
                             ukazovladani(l,3);
                             end;
 j:=(xmys-lhx) div (velp*2);
 i:=(ymys-lhy) div (velp*2);
 if (j>=0)and(j<=sirka)and(i>=0)and(i<=vyska) then
  begin
  k:=0; {jak jsme na tom s konstrukci okolo tohohle policka?:}
  if (j<sirka)and(l.veci1[i,j+1].cotoje=jkonstrukce) then inc(k,2);
  if (j>0)and(l.veci1[i,j-1].cotoje=jkonstrukce) then inc(k);
  if (i>0)and(l.veci1[i-1,j].cotoje=jkonstrukce) then inc(k,4);
  if (i<vyska)and(l.veci1[i+1,j].cotoje=jkonstrukce) then inc(k,8);
  if l.veci1[i,j].cotoje=jkonstrukce then inc(k,16);
  if lmys then {pridani}
   case vyber.hodnota of
   1:begin{konstrukce}
     if k and 16=0 then begin
                        zrus(l,i,j);
                        l.veci1[i,j].cotoje:=jkonstrukce;
                        vyreskonstrukci(l);
                        end;
     end;
   2:begin{kabina}
     if k and 16<>0 then begin
                         zrus(l,i,j);
                         l.hpkabiny:=_hpkabiny;
                         l.xkabiny:=j;
                         l.ykabiny:=i;
                         end;
     end;
   3:begin{nadrze}
     if (k<>0)and(k and 16=0) then begin
                                   zrus(l,i,j);
                                   l.veci1[i,j].cotoje:=jnadrz;
                                   vyreskonstrukci(l);
                                   end;
     end;
   4:begin{zasobniky}
     if (k<>0)and(k and 16=0) then begin
                                   zrus(l,i,j);
                                   l.veci1[i,j].cotoje:=jzasobnik;
                                   vyreskonstrukci(l);
                                   end;
     end;
   5:begin{pancir}
     if l.veci1[i,j].cotoje in [1..3] then l.veci1[i,j].indexpancire:=vybranypancir;
     end;
   6,7:begin{motory}
       if k and 16<>0 then
        if uhelok(j,i,vybranyuhel,vyber.hodnota=7)
          then begin
               if vyber.hodnota=6 then l.veci2[i,j].cotoje:=jmalymotor
                                  else l.veci2[i,j].cotoje:=jvelkymotor;
               l.veci2[i,j].klavesa1:=zadejklavesu(1);
               l.veci2[i,j].klavesa2:=zadejklavesu(2);
               l.veci2[i,j].smer:=vybranyuhel;
               end
          else infokno(320,400,wt.dej(kstryskamusimitmisto),true);
       end;
   8,9:begin{dela}
       if k and 16<>0 then begin
                           if vyber.hodnota=8 then l.veci2[i,j].cotoje:=jmaledelo
                                              else l.veci2[i,j].cotoje:=jvelkedelo;
                           l.veci2[i,j].klavesa1:=zadejklavesu(0);
                           l.veci2[i,j].smer:=vybranyuhel;
                           end;
       end;
   10:zobrazpodrobnosti(j,i);{upravy ovladani}
   end
  else if pmys then{odebrani}
   case vyber.hodnota of
   1:if l.veci1[i,j].cotoje=jkonstrukce then begin
                                             l.veci1[i,j].cotoje:=jnic;
                                             l.veci2[i,j].cotoje:=jnic;
                                             l.veci1[i,j].indexpancire:=0;
                                             vyreskonstrukci(l);
                                             end;
   2:l.hpkabiny:=0;
   3:if l.veci1[i,j].cotoje=jnadrz then begin
                                        l.veci1[i,j].cotoje:=jnic;
                                        l.veci1[i,j].indexpancire:=0;
                                        vyreskonstrukci(l);
                                        end;
   4:if l.veci1[i,j].cotoje=jzasobnik then begin
                                           l.veci1[i,j].cotoje:=jnic;
                                           l.veci1[i,j].indexpancire:=0;
                                           vyreskonstrukci(l);
                                           end;
   5:l.veci1[i,j].indexpancire:=0;
   6:if l.veci2[i,j].cotoje=jmalymotor then l.veci2[i,j].cotoje:=jnic;
   7:if l.veci2[i,j].cotoje=jvelkymotor then l.veci2[i,j].cotoje:=jnic;
   8:if l.veci2[i,j].cotoje=jmaledelo then l.veci2[i,j].cotoje:=jnic;
   9:if l.veci2[i,j].cotoje=jvelkedelo then l.veci2[i,j].cotoje:=jnic;
   10:zobrazpodrobnosti(j,i);
   end;
  if vyber.hodnota<>10 then begin kvyp; mrizka; krl(l,lhx,lhy,skryjpancz.hodnota); kzap; end;
  end;
 if keypressed then begin
                    w:=xreadkey;
                    if w=xF4 then screenshot;
                    end;
 if (soubort.hodnota=1)or(upcase(chr(w))=wt.dej(kssouborhk))
   then begin
        tmp:=vybersouborokno(wt.dej(ksnadpisvyberulode),'LOD','.');
        if (tmp<>'')and not wokzruseno then begin
                                            uriznikoncovku(tmp);
                                            soubor:=tmp;
                                            vypissoubor;
                                            end;
        end;
 if (savet.hodnota=1)or(w=xF2) then begin
                                    l.jmeno:=jmenotp.hodnota;
                                    ulozlod(l,soubor);
                                    end;
 if (loadt.hodnota=1)or(w=xF3) then begin
                                    nactilod(l,soubor);
                                    jmenotp.hodnota:=l.jmeno;
                                    prekresli;
                                    end;
 if konect.hodnota=1 then w:=27;
 repeat kurzor until stavtlacitek=0;
 if w=27 then begin {kontrola kolize motoru}
              for i:=0 to vyska do
               begin
               if w=0 then break;
               for j:=0 to sirka do
                if ((l.veci2[i,j].cotoje=jmalymotor)or(l.veci2[i,j].cotoje=jvelkymotor))
                   and not uhelok(j,i,l.veci2[i,j].smer,l.veci2[i,j].cotoje=jvelkymotor)
                  then begin
                       okokno('%%n'+wt.dej(wtpozor)+'%%N'+wt.dej(ksohrozenotryskou));
                       w:=0;
                       break;
                       end;
               end;
              end;
 until w=27;
vyber.zrus; srott.zrus; savet.zrus; loadt.zrus;
kvyp; _fill2(0);
resetuj;
nastavkurzor(wokkurzor);
zruskurzor(k2);
End;{editor}

procedure initlod(var l:lod; kde:word);
var i,j:byte;
Begin
with l do begin
          HPkabiny:=_hpkabiny; xT:=20; yT:=20; vaha:=3000; J:=70000;
          x:=kde; y:=_maxy div 2; vx:=0; vy:=0; omega:=0;
          if kde>320 then uhel:=180 else uhel:=0;
          palivo:=0; strelivo:=0;
          end;
for i:=0 to vyska do for j:=0 to sirka do
 begin
 case l.veci1[i,j].cotoje of jkonstrukce:l.veci1[i,j].hp:=hpkonstrukce;
                             jnadrz:begin
                                    l.veci1[i,j].hp:=hpnadrze;
                                    inc(l.palivo,obsahnadrze);
                                    l.veci1[i,j].obsah:=obsahnadrze;
                                    end;
                             jzasobnik:begin
                                       l.veci1[i,j].hp:=hpzasobniku;
                                       inc(l.strelivo,obsahzasobniku);
                                       l.veci1[i,j].obsah:=obsahzasobniku;
                                       end;
                             end;
 if l.veci1[i,j].indexpancire<>0 then l.veci1[i,j].hppancire:=hppancire;
 case l.veci2[i,j].cotoje of jmalymotor:l.veci2[i,j].hp:=hpmalehomotoru;
                             jvelkymotor:l.veci2[i,j].hp:=hpvelkehomotoru;
                             jmaledelo:l.veci2[i,j].hp:=hpmalehodela;
                             jvelkedelo:l.veci2[i,j].hp:=hpvelkehodela;
                             end;
 if l.veci2[i,j].cotoje<>jnic then l.veci2[i,j].teplota:=0;{to vynuluje i polozku "jede"}
 end;
with l do begin maxpaliva:=palivo; maxstreliva:=strelivo; end;
End;{initlod}

procedure UkazPalivoAStrelivo(var l:lod; kde:word);
const minuhel=180-45; maxuhel=360+45;
var uhel:integer;
Begin
if epesnipristroje
  then begin
       if kde<320 then inc(kde,21) else dec(kde,21);
       {palivomer:}
       if l.maxpaliva<>0 then
        begin
        _filledellipse(kde,404,20,20,44);
        _filledellipse(kde,404,17,17,8);
        __vysec(kde,404,-maxuhel,0,5,16,16,2);
        __vysec(kde,404,-minuhel-30,-minuhel,5,16,16,12);
        __vysec(kde,404,-minuhel,-maxuhel,5,16,16,39);
        _oblouk(kde,404,80,190,10,20,20,15);
        {rucicka:}
        uhel:=(l.palivo*longint(maxuhel-minuhel))div l.maxpaliva+minuhel;
        _line(kde,404,kde+longint(16)*rychlycos(uhel) div 10000,404+longint(16)*rychlysin(uhel) div 10000,15);
        _filledellipse(kde,404,2,2,15);
        end;
       {strelivomer:}
       if l.maxstreliva<>0 then
        begin
        _filledellipse(kde,455,20,20,11);
        _filledellipse(kde,455,17,17,8);
        __vysec(kde,455,-maxuhel,0,5,16,16,2);
        __vysec(kde,455,-minuhel-30,-minuhel,5,16,16,12);
        __vysec(kde,455,-minuhel,-maxuhel,5,16,16,3);
        _oblouk(kde,455,80,190,10,20,20,15);
        {rucicka:}
        uhel:=(l.strelivo*longint(maxuhel-minuhel))div l.maxstreliva+minuhel;
        _line(kde,455,kde+longint(16)*rychlycos(uhel) div 10000,455+longint(16)*rychlysin(uhel) div 10000,15);
        _filledellipse(kde,455,2,2,15);
        end;
       end
  else begin
       if (l.maxpaliva<>0)and(l.palivo<>0) then _vline(kde,479-(l.palivo*longint(479) div l.maxpaliva),479,14);
       if (l.maxstreliva<>0)and(l.strelivo<>0) then _vline(kde+2,479-(l.strelivo*longint(479) div l.maxstreliva),479,3);
       end;
End;{ukazpalivoastrelivo}

procedure PohybVraku; {zaridi pohyb a vykresleni vsech vraku na obrazovce}
const okraj=30;
var predchoziv,uv:uknavrak;
Begin
uv:=prvnivrak; predchoziv:=nil;
while uv<>nil do begin
                 zvazlod(uv^.troska,true);
                 presunlod(uv^.troska);
                 kreslilod(uv^.troska);
                 if (uv^.troska.x<-okraj)or(uv^.troska.x>_maxx+okraj)or(uv^.troska.y<-okraj)or(uv^.troska.y>_maxy+okraj)
                   then if predchoziv=nil then begin
                                               prvnivrak:=prvnivrak^.dalsi;
                                               predchoziv:=uv;
                                               uv:=prvnivrak;
                                               dispose(predchoziv);
                                               predchoziv:=nil;
                                               end
                                          else begin
                                               predchoziv^.dalsi:=uv^.dalsi;
                                               dispose(uv);
                                               uv:=predchoziv^.dalsi;
                                               end
                   else begin
                        predchoziv:=uv;
                        uv:=uv^.dalsi;
                        end;
                 end;
End;{pohybvraku}

procedure Uklid; {vymaze vsechny trosky a strely}
var us:uknastrelu;
    uv:uknavrak;
Begin
while strely<>nil do begin
                     us:=strely;
                     strely:=strely^.dalsi;
                     dispose(us);
                     end;
while prvnivrak<>nil do begin
                        uv:=prvnivrak;
                        prvnivrak:=prvnivrak^.dalsi;
                        dispose(uv);
                        end;
End;{uklid}

function pojistka:boolean; far; {pro COM}
Begin
pojistka:=pressed(1);
End;{pojistka}

function propojeni:boolean; {rozhrani pro propojeni seriovym kabelem}
var cisloportur:roleta;
    rychlosttp:textovepole;
    uart_base:array[1..4] of word absolute 0:$0400;
    b:word;
    nahodt,startt:tlacitko;
    spusteno:boolean;
Begin
spusteno:=false;
propojeni:=false;
_fill2(0);
{uvodni text:}
for b:=0 to 3 do _print(10,4+18*b,2,wt.dej(kscomuvod+b));
kreslimac(grdata,40,580,40,100,0);
{vyber portu:}
ramecek(10,90,629,162,11,3,14,0,wt.dej(ksport));
for b:=0 to 2 do _print(100,100+18*b,2,wt.dej(kscomvyberportu+b));
{rychlost:}
ramecek(10,182,629,270,11,3,14,0,wt.dej(ksrychlost));
for b:=0 to 3 do _print(95,192+18*b,2,wt.dej(kscomrychlost+b));
{nahozeni portu:}
ramecek(10,290,629,361,11,3,14,0,wt.dej(ksstartportu));
for b:=0 to 2 do _print(140,300+18*b,2,wt.dej(kscomnahodport+b));
{start hry:}
ramecek(10,381,629,452,11,3,14,0,wt.dej(ksstarthry));
for b:=0 to 2 do _print(140,391+18*b,2,wt.dej(kscomstarthry+b));
{ovladatka:}
cisloportur.nuluj;
for b:=1 to 4 do if uart_base[b]<>0 then cisloportur.pridejpolozky('COM '+nastr(b)) else break;
cisloportur.init(25,114,cisloportu,wt.dej(ksdostupneporty));
rychlosttp.init(30,215,5,nastr(baudy),false,true);
nahodt.init(25,310,wt.dej(ksnahoditport),wt.dej(kscomtlachelp)+wt.dej(kscomtlachelp+1)+'.',4);
startt.init(25,401,wt.dej(ksstarthryt),wt.dej(kscomtlachelp)+wt.dej(kscomtlachelp+2)+'.',4);
{ted ta hlavni cast:}
zapniobsluhumysi; {nutne - po nahozeni portu to bude tak trochu "event-controlled"}
b:=0;
 repeat
 if spusteno {jestli uz bezi prijem}
   then begin
        startt.kontrola;
        if keypressed then b:=xreadkey else b:=0;
        if b=xF4 then screenshot;
        {jestli uz zacal ten druhy:}
        if comrxready and (comrx=cjsemprvni) then begin {potvrdit}
                                                  comtx(cjsemdruhy);
                                                  jsem:=2;
                                                  propojeni:=true;
                                                  break;
                                                  end;
        {jestli zacinam ja:}
        if (startt.hodnota=1)or(upcase(chr(b))=wt.dej(kscomtlachelp+2))
          then begin
               comtx(cjsemprvni);
               kresetuj;
                repeat {cekame na potvrzeni}
                if keypressed then b:=xreadkey else b:=0;
                until (comrxready and (comrx=cjsemdruhy)) or (b=27);
               if b<>27 then begin
                             jsem:=1;
                             propojeni:=true;
                             break;
                             end;
               end;
        end
   else begin {if not spusteno}
        cekej;
        cisloportur.kontrola;
        rychlosttp.kontrola;
        nahodt.kontrola;
        if keypressed then b:=xreadkey else b:=0;
        if b=xF4 then screenshot;
        if (nahodt.hodnota=1)or(upcase(chr(b))=wt.dej(kscomtlachelp+1))
          then if cominstall(cisloportur.hodnota)
                 then begin
                      cisloportu:=cisloportur.hodnota;
                      baudy:=valf(rychlosttp.hodnota,9600);
                      comsetup(baudy,comnone,com8d2s);
                      comflushtx; comflushrx;
                      napis(15,461,15,2,zarovnej(wt.dej(kscomportok),76,_nastred,' '));
                      spusteno:=true;
                      end
                 else napis(15,461,15,12,zarovnej(wt.dej(kscomportko),76,_nastred,' '));
        resetuj;
        end;
 until b=27; {nebo breakem}
zrusobsluhumysi;
cisloportur.zrus;
kvyp;
if (b=27) and spusteno then comuninstall;
End;{propojeni}

procedure KresliCas; {vykresli ukazatel spotrebovaneho casu}
Begin
_rectangle(38,1,40+dk shl 3+2,5,2);
__hline(40,40+getms shl 3,3,12);
End;{kreslicas}

procedure UlozNastaveni;
var k:konfigurace;
Begin
k.init;
if k.pridejsekci(wt.dej(ksnhra)) and
   k.zadejpolozku(wt.dej(ksn1hrac),hrac[1]) and
   k.zadejpolozku(wt.dej(ksn2hrac),hrac[2]) and
   k.zadejpolozku(wt.dej(ksn1lod),lodnisoubory[1]) and
   k.zadejpolozku(wt.dej(ksn2lod),lodnisoubory[2]) and
   k.zadejcislo(wt.dej(ksnkulprist),ord(epesnipristroje)) and
   k.zadejcislo(wt.dej(ksncasomira),ord(debug)) and
   k.zadejcislo(wt.dej(ksnzacyklit),ord(zacykleno)) and
   k.zadejcislo(wt.dej(ksnjas),_jas) and
   k.zadejpolozku(wt.dej(ksnpozadi),souborpozadi) and
   k.zadejcislo(wt.dej(ksncisloportu),cisloportu) and
   k.zadejcislo(wt.dej(ksnrychlostportu),baudy) and
   k.uloz(cfgsoubor) then {je to dobry, a jestli ne, houby se deje};
k.zrus;
End;{uloznastaveni}

procedure NactiNastaveni;
var k:konfigurace;
    l:longint;
Begin
k.init;
k.nacti(cfgsoubor,wt.dej(ksnhra));
hrac[1]:=k.prectipolozku(wt.dej(ksn1hrac)); if hrac[1]=#0 then hrac[1]:=wt.dej(ksndefhrac1);
hrac[2]:=k.prectipolozku(wt.dej(ksn2hrac)); if hrac[2]=#0 then hrac[2]:=wt.dej(ksndefhrac2);
lodnisoubory[1]:=k.prectipolozku(wt.dej(ksn1lod));
if (lodnisoubory[1]=#0)or(lodnisoubory[1]='') then lodnisoubory[1]:=wt.dej(ksndeflod1);
if not existujesoubor(lodnisoubory[1]+'.LOD') then lodnisoubory[1]:='';
lodnisoubory[2]:=k.prectipolozku(wt.dej(ksn2lod));
if (lodnisoubory[2]=#0)or(lodnisoubory[1]='') then lodnisoubory[2]:=wt.dej(ksndeflod2);
if not existujesoubor(lodnisoubory[2]+'.LOD') then lodnisoubory[2]:='';
epesnipristroje:=k.precticislo(wt.dej(ksnkulprist))=1;
debug:=k.precticislo(wt.dej(ksncasomira))=1;
zacykleno:=k.precticislo(wt.dej(ksnzacyklit))<>0;
l:=k.precticislo(wt.dej(ksnjas)); if (l<0)or(l>200) then _jas:=100 else _jas:=l;
souborpozadi:=k.prectipolozku(wt.dej(ksnpozadi)); if souborpozadi=#0 then souborpozadi:=wt.dej(ksndefpoz);
l:=k.precticislo(wt.dej(ksncisloportu)); if (l<0)or(l>4) then cisloportu:=1 else cisloportu:=l;
l:=k.precticislo(wt.dej(ksnrychlostportu)); if (l<2)or(l>115200) then baudy:=9600 else baudy:=l;
k.zrus;
End;{nactinastaveni}

procedure HlavniMenu;
type poletp=array[1..2] of textovepole;
var jasco:ciselnaosa;
    zacyklz:zatrzitko;
    pozadit,myst,konect,creditst,helpt:tlacitko;
    startsoloh,start2h,startcomh,editorh:hotspot;
    pozaditp:textovepole;
    jmenohrtp,souborlodetp,jmenolodetp:poletp;
    vyberlodet,ovladanit:array[1..2] of tlacitko;
    o:word;
    b:byte;
    ret:string[12];
    r40:str40;
    zmenitkurzor,zmenenykurzor:boolean;
    k2:tkurzor;
{}function NactiJmenoLode(ktere:byte; var vysledek:str40):boolean;
{}var f:file of str40;
{}Begin
{}assign(f,lodnisoubory[ktere]+'.LOD');
{}reset(f);
{}read(f,vysledek);
{}close(f);
{}nactijmenolode:=ioresult=0;
{}End;{nactijmenolode}
{}procedure InitHrace(ktereho:byte; kdex,kdey:word);
{}Begin
{}ramecek(kdex,kdey,kdex+430,kdey+95,11,3,14,0,wt.dej(ksprvnihrac-1+ktereho));
{}_print(kdex+8,kdey+14,2,wt.dej(ksjehojmeno));
{}_print(kdex+8,kdey+40,2,wt.dej(ksajeholod));
{}jmenohrtp[ktereho].init(kdex+105,kdey+11,39,hrac[ktereho],false,false);
{}souborlodetp[ktereho].init(kdex+105,kdey+37,8,lodnisoubory[ktereho],false,true);
{}vyberlodet[ktereho].init(kdex+180,kdey+37,wt.dej(ksvybratjinou),wt.dej(ksvybratjinouhelp),0);
{}ovladanit[ktereho].init(vyberlodet[ktereho].x+vyberlodet[ktereho].sirka+6,
{}                        kdey+37,wt.dej(ksukazovladani),wt.dej(ksukazovlhelp),0);
if not nactijmenolode(ktereho,r40) then r40:='';
{}jmenolodetp[ktereho].init(kdex+97,kdey+62,40,r40,false,false);
{}End;{inithrace}
{}procedure VypisLod(kterou:byte);{zobrazi soubor a jmeno dane lode, popr. chybove hlaseni}
{}Begin
{}if lodnisoubory[kterou]='' then begin
{}                                souborlodetp[kterou].hodnota:='???';
{}                                jmenolodetp[kterou].hodnota:=wt.dej(ksnevybranalod);
{}                                end;
{}souborlodetp[kterou].zobraz;
{}jmenolodetp[kterou].zobraz;
{}End;{vypislod}
Begin{hlavnimenu}
reset(binsoubor,1);
if ioresult<>0 then begin okokno(wt.dej(kschybidata2)); stavhry:=konec; exit; end;
seek(binsoubor,ks2_kur);
nactikurzor(k2,binsoubor);
close(binsoubor); if ioresult<>0 then {kaslem na to};
_fill2(0);
kreslimac(grdata,41,0,0,100,0);
ramecek(2,414,220,477,11,3,14,0,wt.dej(ksnadpisvesmir));
ramecek(225,377,436,477,11,3,14,0,wt.dej(ksnadpisnastaveni));
ramecek(441,371,637,477,11,3,14,0,wt.dej(ksnadpiszbytek));
inithrace(1,100,120);
kvyp;
inithrace(2,170,240);
vypislod(1); vypislod(2);
{vesmir:}
pozaditp.init(10,425,8,souborpozadi,false,true);
pozadit.init(85,425,wt.dej(ksvybratpozadi),wt.dej(ksvybratpozadihelp),0);
zacyklz.init(20,455,wt.dej(ksnekonecny),wt.dej(kszacyklhelp),zacykleno);
{nastaveni:}
myst.init(232,388,wt.dej(ksnastavenimysi),wt.dej(ksmyshelp),0);
jasco.init(232,434,160,0,200,_jas,wt.dej(ksjas),'','',true,0);
{zbytek:}
helpt.init(448,381,wt.dej(kshelp),wt.dej(kshelphelp),0);
creditst.init(448,411,wt.dej(kscredits),wt.dej(kscreditshelp),0);
konect.init(448,441,wt.dej(kskonec),wt.dej(kskonechelp),3);
{spousteni hry:}
startsoloh.init(6,12,163,107,true,wt.dej(kssolohelp));
start2h.init(2,262,148,392,true,wt.dej(ks2na1help));
startcomh.init(259,10,531,105,true,wt.dej(kscomhelp));
{editor:}
editorh.init(558,52,634,231,true,wt.dej(kseditorhelp));
resetuj; zmenenykurzor:=false; zmenitkurzor:=false;
 repeat
 cekejnacokoli;
 zacyklz.kontrola; startsoloh.kontrola; start2h.kontrola; startcomh.kontrola;
 konect.kontrola;
 for b:=1 to 2 do begin
                  jmenohrtp[b].kontrola;
                  vyberlodet[b].kontrola;
                  ovladanit[b].kontrola;
                  end;
 editorh.kontrola; jasco.kontrola;
 pozadit.kontrola; myst.kontrola; helpt.kontrola; creditst.kontrola;
 with startsoloh do zmenitkurzor:=mysvpoli(a,b,c,d);
 with start2h do if mysvpoli(a,b,c,d) then zmenitkurzor:=true;
 with startcomh do if mysvpoli(a,b,c,d) then zmenitkurzor:=true;
 with editorh do if mysvpoli(a,b,c,d) then zmenitkurzor:=true;
 if zmenitkurzor then begin
                      if not zmenenykurzor then begin
                                                nastavkurzor(k2);
                                                zmenenykurzor:=true;
                                                end
                      end
                 else if zmenenykurzor then begin
                                            nastavkurzor(wokkurzor);
                                            zmenenykurzor:=false;
                                            end;
 if keypressed then o:=xreadkey else o:=0;
 if (konect.hodnota=1)or(o=27) then stavhry:=konec;
 if (startsoloh.hodnota=1)or(upcase(chr(o))='S') then stavhry:=sololet;
 if (start2h.hodnota=1)or(chr(o)='2') then stavhry:=dvanajednom;
 if (startcomh.hodnota=1)or(upcase(chr(o))='C') then stavhry:=dvapokabelu;
 if (editorh.hodnota=1)or(upcase(chr(o))='E') then stavhry:=stavba;
 for b:=1 to 2 do if vyberlodet[b].hodnota=1
                    then begin
                         ret:=vybersouborokno(wt.dej(ksdostupnelode),'LOD','.');
                         if not wokzruseno
                           then begin
                                dec(ret[0],4);
                                lodnisoubory[b]:=ret;
                                if nactijmenolode(b,r40)
                                  then begin
                                       souborlodetp[b].hodnota:=ret;
                                       jmenolodetp[b].hodnota:=r40;
                                       end
                                  else begin
                                       lodnisoubory[b]:='';
                                       okokno(wt.dej(kslodnejdeprecist));
                                       end;
                                vypislod(b);
                                end;
                         end;
 if ovladanit[1].hodnota=1 then ukazovladani(lode[1],1);
 if ovladanit[2].hodnota=1 then ukazovladani(lode[2],2);
 if (pozadit.hodnota=1)or(upcase(chr(o))=wt.dej(kspozadihk))
   then begin
        ret:=vybersouborokno(wt.dej(ksdostupnapozadi),'PCX','.');
        if not wokzruseno and (ret<>'') and existujesoubor(ret) then begin
                                                                     dec(ret[0],4);
                                                                     souborpozadi:=ret;
                                                                     stavhry:=zmenapozadi;
                                                                     end;
        end;
 if (myst.hodnota=1)or(upcase(chr(o))=wt.dej(ksmyshk)) then nastavmysokno(false);
 if (helpt.hodnota=1)or(o=xF1) then begin
                                    b:=nabidka(helpt.x,helpt.y-115,wt.dej(ksmoznostihelpu));
                                    if b<>0 then stavhry:=manual1+b-1;
                                    end;
 if (creditst.hodnota=1)or(upcase(chr(o))=wt.dej(kscreditshk)) then stavhry:=credits;
 if jasco.zmeneno then nastavpaletu(hernipaleta,0,255,jasco.hodnota);
 if o=xF4 then screenshot;
 resetuj;
 until stavhry<>menu;
kvyp;
zacykleno:=zacyklz.hodnota;
for b:=1 to 2 do hrac[b]:=jmenohrtp[b].hodnota;
if zmenenykurzor then nastavkurzor(wokkurzor);
zruskurzor(k2);
End;{hlavnimenu}

procedure outro(kdovyhral:byte);
var w:word;
    ret:string;
Begin
if kdovyhral=1 then zatmictvercem(round(lode[2].x),round(lode[2].y))
               else if kdovyhral=2 then zatmictvercem(round(lode[1].x),round(lode[1].y))
                                   else zatmictvercem(320,240);
if kdovyhral=0 then ret:=zarovnej(wt.dej(ksremiza),40,_nastred,' ')
               else ret:=zarovnej(wt.dej(ksslava),40,_nastred,' ');
_nastavtext(5,6,16);
_print(1,35,21,ret);
_nastavtext(3,5,16);
_print(8,43,1,ret);
_nastavtext(2,4,16);
_print(12,50,11,ret);
if kdovyhral=0 then begin
                    _nastavtext(2,2,16);
                    for w:=0 to 2 do stintext(2,220+35*w,12,21,2,zarovnej(wt.dej(ksremiza+1+w),40,_nastred,' '));
                    end
               else begin
                    _nastavtext(1,1,8);
                    stintext(7,180,12,21,1,zarovnej(wt.dej(ksvyhral),80,_nastred,' '));
                    stintext(7,380,12,21,1,zarovnej(wt.dej(ksprohral),80,_nastred,' '));
                    _nastavtext(2,2,16);
                    stintext(7,230,14,15,-1,zarovnej(hrac[kdovyhral],40,_nastred,' '));
                    for w:=0 to 4 do _hline(5+70*w,635-70*w,270+10*w,14);
                    stintext(7,420,7,29,-1,zarovnej(hrac[2-kdovyhral+1],40,_nastred,' '));
                    end;
_nastavtext(1,1,8);
resetuj; cekej;
if keypressed and (xreadkey=xF4) then screenshot;
stavhry:=menu;
End;{outro}

procedure VypisRadek(indextextu:word); {pro uvod kabelove hry}
Begin
stintext(155,213+18*pom,11,0,1,wt.dej(indextextu));
inc(pom);
End;{vypisradek}

procedure UkazHelp(stranka:byte); {zobrazi prislusnou kapitolu manualu}
var pozice:word;
Begin
stavhry:=menu;
if stranka=0 then exit; {teoreticky nemozne}
_fill2(0);
kreslimac(grdata,46+stranka,0,0,100,0);
for pozice:=0 to kspocetradkuhelpu-1 do _print(30,40+17*pozice,3,wt.dej(kszacatekhelpu+kspocetradkuhelpu*(stranka-1)+pozice));
resetuj; cekej;
if keypressed and (xreadkey=xF4) then screenshot;
End;{ukazhelp}

procedure UkazCredits;
const pocethvezd=80;
      lhx=100; lhy=30; sirka=640-2*lhx; vyska=480-2*lhy;
      roztecradku=20;
      start1=230; start2=0; start3=-200;
var hvezdy:array[1..pocethvezd,1..2] of integer;
    i:integer;
    w:word;
    konec:boolean;
Begin
_fill2(0); _nastavstrankovani; _fill2(0);
for w:=1 to pocethvezd do begin
                          hvezdy[w,1]:=random(sirka)+lhx;
                          hvezdy[w,2]:=random(vyska)+lhy;
                          end;
i:=lhy+vyska;
_setwindow(lhx,lhy,lhx+sirka,lhy+vyska);
konec:=false;
 repeat
 startcekani;
 _bar(lhx,lhy,lhx+sirka,lhy+vyska,0);
 for w:=1 to pocethvezd do _putpixel(hvezdy[w,1],hvezdy[w,2],15);
 if (i<=start1)and(i>start1-100) then kreslimac(grdata,44,600+7*(i-start1)+random(6),400+random(4),50,0);
 if (i<=start2)and(i>start2-100) then kreslimac(grdata,43,50-7*(i-start2)+random(6),100+random(4),90,0);
 if (i<=start3)and(i>start3-95) then kreslimac(grdata,42,600+5*(i-start3),
                                               400-sqr(i-start3+50)div 6,70,100-20*(i-start3)div 11);
 for w:=kszacatekcredits to kskoneccredits do
  if ((w-kszacatekcredits)*roztecradku+i>=lhy)and((w-kszacatekcredits)*roztecradku+i<=lhy+vyska-8)
    then _print(lhx+40,(w-kszacatekcredits)*roztecradku+i,14,wt.dej(w));
 _swap;
 dec(i);
 if keypressed then if xreadkey=xF4 then screenshot
                                    else konec:=true;
 pockej(50);
 until konec or (i<-(kskoneccredits-kszacatekcredits)*roztecradku+10);
_nastavstrankovani;
_setdefaultwindow;
stavhry:=menu;
End;{ukazcredits}

procedure ukazintro;
var minulyjas,i:byte;
    druhapaleta,tretipaleta:rgbpal256;
Begin
startcekani;
 repeat until keypressed or (getms>1000);{cas pro nabehnuti monitoru}
minulyjas:=_jas;
zmenjas(hernipaleta,0,255,0,0);
_fill2(0);
_print(100,230,15,wt.dej(ksintro1));
zmenjas(hernipaleta,0,15,minulyjas,5);
startcekani;
 repeat until keypressed or (getms>2000);
zmenjas(hernipaleta,0,15,0,5);
scroff;
_fill2(240);
zobrazpcx(111,52,'KSINTRO1.DAT',true);
zjistipaletu(druhapaleta); zmenjas(druhapaleta,0,255,0,0);
scron;
zmenjas(druhapaleta,0,255,minulyjas,5);
startcekani;
 repeat until keypressed or (getms>2000);
zmenjas(druhapaleta,0,255,200,10);
_fill2(240);
zobrazpcx(112,107,'KSINTRO2.DAT',false);
zmenjas(druhapaleta,0,255,minulyjas,10);
startcekani;
fillchar(tretipaleta,sizeof(tretipaleta),63);
for i:=0 to 255 do tretipaleta[i,3]:=21;
 repeat until keypressed or (getms>3000);
zmenpaletu(druhapaleta,tretipaleta,0,255,20);
_fill2(14);
if not keypressed then pockej(500);
nastavpaletu(hernipaleta,0,47,100);
nastavbarvu(hernipaleta,4,63,63,21);
_print(180,150,0,wt.dej(ksintro2));
_nastavtext(5,6,40);
_print(80,230,4,wt.dej(ksintro3));
if not keypressed then pockej(500);
zmenjas(hernipaleta,0,15,minulyjas,5);
startcekani;
 repeat until keypressed or (getms>1000);
zmenbarvu(hernipaleta,4,42,0,0,20);
startcekani;
 repeat until keypressed or (getms>2000);
stopcekani;
zmenjas(hernipaleta,0,15,0,5);
_fill2(0);
zmenjas(hernipaleta,0,47,minulyjas,0);
kresetuj;
End;{ukazintro}

BEGIN
{XMS:}
if xmsresult<>0 then begin
                     writeln('XMS driver not present or doesn''t work properly.');
                     writeln('If you don''t have disk cache (Smartdrv etc.), everything will be VERY SLOW.');
                     end;
{texty:}
write('Loading texts... ');
wt.init('KSDATA1.DAT','','');
if wt.pocetradku=0 then chyba('Missing file KSDATA1.DAT or disk read error.',0);
writeln('OK.');
{binarni data:}
assign(binsoubor,'KSDATA2.DAT');
reset(binsoubor,1);
if ioresult<>0 then begin writeln(wt.dej(kschybidata2)); wt.zrus; halt; end;
{zakladni paleta:}
blockread(binsoubor,hernipaleta,sizeof(hernipaleta));
{fonty, kurzor:}
_nactifont(wokfont,binsoubor);
_nactifont(vetsifont,binsoubor);
nactikurzor(wokkurzor,binsoubor);
{graficka data:}
nactimac(grdata,binsoubor);
close(binsoubor);
if ioresult<>0 then begin okokno(wt.dej(kschybidata2)); wt.zrus; halt; end;
{konfigurace:}
cfgsoubor:='KS.CFG';
nactinastaveni;
nactinastavenimysi;
{grafika:}
_frekvence:=85;
_setmode(_640x480);{----------------------------------}
{font:}
_nastavfont(vetsifont,false);
{mys:}
initmys;
nastavkurzor(wokkurzor);
{graficke intro:}
ukazintro;
{obrazek na pozadi:}
_fill(0);
for pom:=0 to 80 do begin
                    _putpixel(random(640),random(480),15);
                    _putpixel(random(640),random(480),7);
                    _putpixel(random(640),random(480),8);
                    end;
_nastavtext(2,2,16);
_print(250,230,14,wt.dej(ksnacitam));
_nastavstrankovani;
_fill2(0);
pom:=_jas;
zobrazpcx(0,0,souborpozadi+'.PCX',true);
savescr(pozadi,false);
zjistipaletu(hernipaleta);
nastavpaletu(hernipaleta,0,255,pom);
_nastavstrankovani;
{posledni drobnosti:}
_nastavtext(1,1,8);
strely:=nil; prvnivrak:=nil; povolitklavesy:=false; breakfunc:=pojistka;
stavhry:=menu;
{hlavni cyklus:}
 repeat
 {vychozi stav zde: vypnuty kurzor, nastaveny font 8x16, velikost 1,1,8,
  vypnute strankovani, aktualni stranka nedefinovana}
 case stavhry of
  menu:hlavnimenu;
  stavba:editor;
  zmenapozadi:begin
              pom:=_jas;
              _nastavstrankovani;
              ZobrazPCX(0,0,souborpozadi+'.PCX',true);
              savescr(pozadi,true);
              zjistipaletu(hernipaleta);
              nastavpaletu(hernipaleta,0,255,pom);
              _nastavstrankovani;
              stavhry:=menu;
              end;
  SoloLet:begin
          nactilod(lode[1],lodnisoubory[1]);
          initlod(lode[1],uprostred);
          initklav;
          _nastavstrankovani;
           repeat
           startcekani;
           loadscr(pozadi,false);
           zvazlod(lode[1],false);
           rizeni(lode[1]);
           presunlod(lode[1]);
           kreslilod(lode[1]);
           ukazpalivoastrelivo(lode[1],vlevo);
           presunstrely;
           pohybvraku;
           if debug then kreslicas;
           _swap;
           pockej(dk);
           until (lode[1].hpkabiny=0) or pressed(1);
          _nastavstrankovani;
          zrusklav;
          stavhry:=menu;
          end;
  DvaNaJednom:begin
              nactilod(lode[1],lodnisoubory[1]);
              initlod(lode[1],vlevo);
              nactilod(lode[2],lodnisoubory[2]);
              initlod(lode[2],vpravo);
              initklav;
              _nastavstrankovani;
               repeat
               startcekani;
               loadscr(pozadi,false);
               zvazlod(lode[1],false);
               zvazlod(lode[2],false);
               rizeni(lode[1]);
               rizeni(lode[2]);
               presunlod(lode[1]);
               presunlod(lode[2]);
               kreslilod(lode[1]);
               kreslilod(lode[2]);
               ukazpalivoastrelivo(lode[1],vlevo);
               ukazpalivoastrelivo(lode[2],vpravo);
               presunstrely;
               pohybvraku;
               if debug then kreslicas;
               _swap;
               pockej(dk);
               until (lode[1].hpkabiny=0)or(lode[2].hpkabiny=0) or pressed(1);
              _nastavstrankovani;
              zrusklav;
              if lode[1].hpkabiny=0 then if lode[2].hpkabiny=0 then stavhry:=remiza
                                                               else stavhry:=vyhral2
                                    else if lode[2].hpkabiny=0 then stavhry:=vyhral1
                                                               else stavhry:=menu;
              end;
  DvaPoKabelu:if propojeni then
              begin
              for pom:=1 to 45 do begin {podklad pro text}
                                  startcekani;
                                  __box(320-integer(4)*pom,240-pom,
                                        320+integer(4)*pom,240+pom,29,20,25);
                                  pockej(5);
                                  end;
              initklav;
              pom:=0;
              vypisradek(ksodesilamlod);
              nactilod(lode[1],lodnisoubory[1]);
              comtx(cposilamlod);
              comtxblock(lode[1],velikostlode); {lod --->}
              vypisradek(kslododeslana);
              comtxblock(hrac[1],40); {jmeno hrace --->}
              if jsem=1 then comtx(byte(zacykleno));{zacykleni --->}
              repeat until pressed(1) or (comrx=cposilamlod);
              if pressed(1) then begin comuninstall; zrusklav; stavhry:=menu; continue; end;
              comrxblock(lode[2],velikostlode);{<--- lod}
              vypisradek(kslodprijata);
              comrxblock(hrac[2],40);{<--- jmeno hrace}
              if jsem=2 then zacykleno:=boolean(comrx);{<--- zacykleni}
              comtx(cmuzemezacit);
              repeat until pressed(1) or (comrx=cmuzemezacit);
              if pressed(1) then begin comuninstall; zrusklav; stavhry:=menu; continue; end;
              if jsem=1 then begin
                             initlod(lode[1],nalevo);
                             initlod(lode[2],napravo);
                             end
                        else begin
                             initlod(lode[1],napravo);
                             initlod(lode[2],nalevo);
                             end;
              _nastavstrankovani;
               repeat
               startcekani;
               zvazlod(lode[1],false);
               rizeni(lode[1]);
               presunlod(lode[1]);
               odeslilod(lode[1]);
               loadscr(pozadi,false);
               kreslilod(lode[1]);
               zvazlod(lode[2],false);
               kabeloverizeniapresun(lode[2]);
               kreslilod(lode[2]);
               ukazpalivoastrelivo(lode[1],vlevo);
               presunstrely;
               pohybvraku;
               if debug then kreslicas;
               _swap;
               if pressed(1)or(lode[1].hpkabiny=0)or(lode[2].hpkabiny=0)
                 then begin
                      stavhry:=menu;
                      comtx(ckoncime);
                      end
                 else if jsem=1 then begin
                                     pockej(dk);
                                     comtx(ckoneccyklumozny);
                                     repeat pom:=comrx until (pom=ckoneccyklupotvrzen)or(pom=ckoncime);
                                     if pom=ckoncime then stavhry:=menu;
                                     end
                                else begin
                                     repeat pom:=comrx until (pom=ckoneccyklumozny)or(pom=ckoncime);
                                     if pom=ckoncime then stavhry:=menu
                                                     else comtx(ckoneccyklupotvrzen);
                                     end;
               until (lode[1].hpkabiny=0)or(lode[2].hpkabiny=0)or(stavhry=menu);
              repeat until comtxempty; {pockame na odeslani poslednich prikazu, aby se to na druhe strane nekouslo}
              comuninstall;
              _nastavstrankovani;
              zrusklav;
              if lode[1].hpkabiny=0 then if lode[2].hpkabiny=0 then stavhry:=remiza
                                                          else stavhry:=vyhral2
                                    else if lode[2].hpkabiny=0 then stavhry:=vyhral1
                                                          else stavhry:=menu;
              end else stavhry:=menu; {if not propojeni}
  vyhral1:outro(1);
  vyhral2:outro(2);
  remiza:outro(0);
  credits:ukazcredits;
  manual1..manual5:ukazhelp(stavhry-manual1+1);
  end;
 uklid;
 until stavhry=konec;
uloznastaveni;
if uloznastavenimysi then {hm};
freexms(pozadi);
zruswoknows;
_zrusfont(vetsifont);
zrusmac(grdata);
zmenjas(hernipaleta,0,255,0,5);
_setmode(0);
END.