(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KSWOKBAR.INC                                                   *)
(*  Obsah: konstanty barev pro jednotku Woknows 3 (upravene barevne schema *)
(*         pro Kosmostrelce)                                               *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: 27.6.2008                                             *)
(*  Pro kompilaci: nic                                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)

const
(***************************** pro objekty: *********************************)
{tlacitko:}
tlhbarva=15;      {barva leveho a horniho okraje}
tpdbarva=23;       {barva praveho a dolniho okraje}
tvbarva=20;        {barva vnitrku}
ttxtbarva=10;     {barva textu}

{zatrzitko:}
zlhbarva=8;      {levy a horni okraj ctverecku}
zpdbarva=28;     {pravy a dolni okraj}
zvbarva=15;      {vnitrek ctverecku}
zzbarva=0;       {"fajfka" ve ctverecku}
ztxtbarva=2;     {text vedle ctverecku}

{prepinac:}
plhbarva=8;   {levy a horni okraj kolecek}
ppdbarva=28;  {pravy a dolni okraj}
pvbarva=15;   {vnitrek kolecek}
ppbarva=0;    {barva puntiku}
ptxtbarva=0;  {texty}

{roleta:}
slhbarva=8;    {levy a horni okraj textoveho pole}
spdbarva=28;   {pravy a dolni okraj textoveho pole}
svbarva=17;    {vypln textoveho pole}
stxtbarva=10;   {text v tomto poli (vybrana polozka)}
srlhbarva=2;   {levy a horni okraj rolety s nabidkou}
srpdbarva=2;   {pravy a dolni okraj rolety}
srvbarva=16;   {vypln rolety}
srntxtbarva=2; {barva textu neaktivnich polozek v rolete}
sratxtbarva=0;{barva aktivnich textu v rolete (tech, na ktere ukazuje mys)}
sravbarva=2;   {podklad aktivnich textu v rolete}
sskrtbarva=12; {kdyz nebyly zadany zadne moznosti, okenko bude touhle barvou preskrtnute}
{rozbalovaci tlacitko ma barvy jako bezne tlacitko}

{posuvnik:}
posbarva=26;    {barva stredni casti posuvniku}
{posuvny ramecek ma barvu jako tlacitka}

{ciselnaosa:}
colhbarva=8;   {levy a horni okraj drazky}
copdbarva=15;  {pravy a dolni okraj drazky}
covbarva=7;    {vypln drazky}
cotxtbarva=2;  {texty a "vroubky" pod drazkou}
{posuvny obdelnicek ma stejne barvy jako tlacitka}

{textovepole:}
tplhbarva=8;        {levy a horni okraj}
tppdbarva=7;       {pravy a dolni okraj}
tpvbarva=17;        {vypln}
tptxtbarva=10;       {neoznaceny text}
tpkbarva=10;        {kurzor}
tpozntxtbarva=0;   {oznaceny text}
tpozntxtpodbarva=2; {podklad oznaceneho textu}

{menu:}
mlhbarva=15;   {levy a horni okraj okna menu}
mpdbarva=8;    {pravy a dolni okraj okna}
mvbarva=7;     {vypln okna}
mtxtbarva=0;   {barva uvodniho textu nad tlacitky}
minlhbarva=8;  {levy a horni okraj neaktivnich tlacitek}
minpdbarva=8;  {pravy a dolni okraj neaktivnich tlacitek}
minvbarva=7;   {vypln neaktivnich tlacitek}
mintxtbarva=8; {barva textu v neaktivnich tlacitkach}
mialhbarva=15; {levy a horni okraj aktivnich tlacitek}
miapdbarva=8;  {pravy a dolni okraj aktivnich tlacitek}
miavbarva=29;  {vypln neaktivnich tlacitek}
miatxtbarva=0; {barva textu v aktivnich tlacitkach}
mislhbarva=8;  {levy a horni okraj stisknutych tlacitek}
mispdbarva=15; {pravy a dolni okraj stisknutych tlacitek}
misvbarva=22;  {vypln stisknutych tlacitek}
mistxtbarva=15;{barva textu ve stisknutych tlacitkach}

{okno:}
olhbarva=7;      {levy a horniho okraj}
opdbarva=8;       {pravy a dolni okraj}
ovbarva=18;        {vypln okna}
oobdbarva=3;      {lista s nadpisem}
obarvanadpisu=15; {text nadpisu}
opozadinamazani=0;{barva, kterou se smaze okno, pokud nestacila pamet na ulozeni pozadi}
oembarva=7;       {barva, kterou se v takovem pripade vypise chybova hlaska}


(************************* pro procedury a funkce: **************************)

{infokno:}
iolhbarva=27;     {levy a horni okraj}
iopdbarva=24;     {pravy a dolni okraj}
iovbarva=14;      {vnitrek}
iobarvatextu=16;  {text}

{okokno, anoneokno:}
txtbarva=2;  {text v okne}

{nabidka:}
nhbarva=8;        {horni pulka rozdelovacich car}
ndbarva=7;       {dolni pulka rozdelovacich car}
ntxtbarva=7;      {neoznaceny text}
nozntxtbarva=0;  {oznaceny text}
nozntxtpodbarva=10;{podklad oznaceneho textu}
{cely ramecek ma barvu jako bezne okno}

{nastaveniklaves:}
nkatxtbarva=14;   {text prave zadavane polozky}
nkatxtpodbarva=12;{pozadi textu prave zadavane polozky}
{ostatni barvy jsou jako u textoveho pole}


{EOF}