(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: KSPOZADI.PAS                                                   *)
(*  Obsah: predzvykavac obrazku na pozadi pro hru Kosmostrelci             *)
(*  Autor: Mircosoft (http://mircosoft.ic.cz)                              *)
(*  Posledni uprava: 29.5.2008                                             *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: KSDATA1.DAT, KSDATA2.DAT                                 *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program VyrobnikPozadi;
uses vesa,pcx,paleta2,woknows4,mys3,cfg,errmsg;
const ks1_kur = 6918;
      kschybidata2=514;
      ksppopis1=689;
      ksppopis2=691;
      kspvyberobrazek=694;
      kspprevoddokoncen=695;
      kspkamulozit=696;
      kspkomentar=697;
      kspulozeno=698;
      kspukladani=699;
      kspsenezdarilo=700;
      ksppokracovat=701;

var JmenoSouboru:string[79];
    PaletaObrazku,PaletaKS:rgbpal256;
    i,j:word;
    pix:byte;
    binsoubor:file;
BEGIN
write('Loading texts... ');
wt.init('KSDATA1.DAT','','');
if wt.pocetradku=0 then chyba('Missing file KSDATA1.DAT or disk read error.',0);
writeln('OK.');
assign(binsoubor,'KSDATA2.DAT');
reset(binsoubor,1);
if ioresult<>0 then begin writeln(wt.dej(kschybidata2)); wt.zrus; halt; end;
blockread(binsoubor,paletaks,sizeof(paletaks));
_nactifont(wokfont,binsoubor);
seek(binsoubor,ks1_kur);
nactikurzor(wokkurzor,binsoubor);
close(binsoubor);
if ioresult<>0 then begin okokno(wt.dej(kschybidata2)); wt.zrus; halt; end;
cfgsoubor:='ks.cfg';
_frekvence:=85;
_setmode(_640x480); initmys;
nastavkurzor(wokkurzor); _nastavfont(wokfont,true);
 repeat
 _fill(0);
 for i:=0 to 1 do _print(20,40+12*i,2,wt.dej(ksppopis1+i));
 for i:=0 to 2 do _print(20,100+12*i,2,wt.dej(ksppopis2+i));
 _print(460,468,9,'(c) Mircosoft 2008');
 jmenosouboru:=vybersouborokno(wt.dej(kspvyberobrazek),'PCX','');
 if wokzruseno or (jmenosouboru='') then break;
 zobrazpcx(0,0,jmenosouboru,true);
 zjistipaletu(paletaobrazku);
 {uprava palety:}
 for i:=255 downto 48 do {posun barev obrazku o 48 nahoru}
  for j:=1 to 3 do paletaobrazku[i,j]:=paletaobrazku[i-48,j];
 for i:=0 to 47 do {nahrazeni nejnizsich 48 barev paletou hry}
  for j:=1 to 3 do paletaobrazku[i,j]:=paletaks[i,j];
 nastavpaletu(paletaobrazku,0,255,100);
 {uprava obrazku:}
 for i:=0 to 479 do
  for j:=0 to 639 do begin
                     pix:=_getpixel(j,i);
                     if pix>207 then pix:=0
                                else inc(pix,48);
                     _putpixel(j,i,pix);
                     end;
 if anoneokno(wt.dej(kspprevoddokoncen)) then
  begin
  jmenosouboru:=vloztextokno(wt.dej(kspkamulozit),8,'',true);
  if (not wokzruseno)and(jmenosouboru<>'') then
   begin
   jmenosouboru:=jmenosouboru+'.PCX';
   if ulozpcx(0,0,_maxx,_maxy,jmenosouboru,wt.dej(kspkomentar),true)
     then infokno(320,240,wt.dej(kspulozeno)+' ('+jmenosouboru+').',true)
     else infokno(320,240,wt.dej(kspukladani)+jmenosouboru+wt.dej(kspsenezdarilo),true);
   end;
  end;
 until not anoneokno(wt.dej(ksppokracovat));
zruswoknows; _setmode(0);
END.